C----------------------------------------------------------------------
C THIS IS THE MAIN FORTRAN PROGRAM
C FEEL FREE TO ADAPT IT TO YOUR NEEDS.
C
C This file is part of aITALC
C Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
C-----------------------------------------------------------------------
      program aitalc
      implicit none
C----------------------------------------------------------------------
C DEFINITIONS OF VARIABLES and FUNCTIONS
      integer icostloop,isqrtsloop
C Set here the number of iterations in each do loop
      parameter (icostloop=5,isqrtsloop=5)
      double precision setcost,setsqrtsman,setfracomega,setlimcost
      double precision setsqrtsmanarray(isqrtsloop)
     &     ,setcostarray(icostloop)
      logical
     &     lrenorm,        !renormalization flag .true./.false.
     &     lwidth,         !propagator's widths .true./.false.
     &     lidentCKM,      !Identity for CKM matrix .true./.false. 
     &     luvcheck,       !UV-check flag
     &     lircheck        !IR-check flag
      common /lflags/ lrenorm,lwidth,lidentCKM,luvcheck,lircheck
      logical lheader,lcostloop,lprintics,lprintfba,llongoutput
      character outputfile*50, commentchar*1
      integer myunit
      integer i,j
      integer ncost,nsqrtsman
      double precision limcost,minsqrtsman,maxsqrtsman
      double precision dcstree,dcsloop,dcsloop2,dcssoft,dcsall
      double precision icstot(4),icsfba(4),errtot(4),errfba(4)
      double precision SOFTPHOTON
      external SOFTPHOTON
C----------------------------------------------------------------------
C INITIALIZATION OF DATA
      data outputfile /"main.log"/, myunit /8/, commentchar /"#"/
C Be consistent with the icostloop and isqrstsloop dimensions
      data setcostarray /-0.9d0,-0.5d0,0d0,0.5d0,+0.9d0/
      data setsqrtsmanarray /1d2,5d2,1d3,1d4,1d5/
      data lheader,lrenorm,lwidth ,lidentCKM,luvcheck,lircheck 
     &     /.true.,.true. ,.false.,.false.  ,.false. ,.false. /
      data lcostloop,lprintics,lprintfba,llongoutput
     &     /.true.  ,.false.  ,.false.  ,.false. /  
C SETTINGS FOR KINEMATICAL VARIABLES CUTS
C For soft photons,
      data setfracomega /0.1d0/  !maximum soft photon energy/sqrtsman
c                       .0725d0 !computed as lorentz inv. for acoll < 10deg
C For integration
      data setlimcost /0.9999d0/ !for integrated cross sections
C----------------------------------------------------------------------
C SETTINGS FOR FLAGS
C They are logical variables: Set them to the value .true. or .false.
C Uncommenting, bring them to the non-default value
c      lrenorm=.false.
c      lwidth=.true.
c      lidentCKM=.true.

c      luvcheck=.true.
c      lircheck=.true.

c      lcostloop=.false.
c      lprintics=.true.
c      lprintfba=.true.
c      llongoutput=.true.
C----------------------------------------------------------------------
C Signature for log file:
      open (unit=myunit,file=outputfile)
      call SIGNATURE(myunit,commentchar,0,llongoutput)
C----------------------------------------------------------------------
C Here it begins the do loop over the setsqrtsman variable

      nsqrtsman=10         !for nqrtsman equally spaced in log scale points
      minsqrtsman=90
      maxsqrtsman=93

c      do i=0,nsqrtsman          !for log spacing
c        setsqrtsman= minsqrtsman
c     &       *DEXP(i*DLOG(maxsqrtsman/minsqrtsman)/nsqrtsman)

c      do i=0,nsqrtsman          !for equal spacing
c        setsqrtsman= minsqrtsman+i*(maxsqrtsman-minsqrtsman)/nsqrtsman

c      do i=1,isqrtsloop                  !for array spacing
      do i=2,2                  !for selected energy
        setsqrtsman=setsqrtsmanarray(i)
C----------------------------------------------------------------------
C And here over setcost variable
        if (.NOT.lcostloop) goto 2
        lheader=.true.

C Uncomment the following for do many points instead of simple array
c        ncost=50 !for ncost equally spaced sample points
c        do j=0,ncost !for setcost equal spacing
c          setcost= -setlimcost+(2*setlimcost/ncost)*j

C Otherwise ()
         do j=1,icostloop !for setcost array
           setcost=setcostarray(j)

           call iniaitalc(setsqrtsman,setcost)
C----------------------------------------------------------------------
C CALL OF THE DIFFERENTIAL CROSS SECTION SUBROUTINE
 1         call DCS(dcstree,dcsloop,dcsloop2)
           dcssoft=SOFTPHOTON(setfracomega)*dcstree
           dcsall=dcstree + dcsloop + dcssoft
C----------------------------------------------------------------------
C PRINTOUT OF DCS
      if (lheader) then
        call SIGNATURE(myunit,commentchar,1,llongoutput)
        lheader=.false.
      endif
      if (llongoutput) then
      print 102
     &     ,setsqrtsman
     &     ,setcost
     &     ,dcstree
     &     ,dcsloop
     &     ,dcssoft
     &     ,dcsall
c     &     ,(dcsloop+dcssoft)/dcstree !percent against born
     &     ,dcsloop2
      write (myunit,fmt=102)
     &     ,setsqrtsman
     &     ,setcost
     &     ,dcstree
     &     ,dcsloop
     &     ,dcssoft
     &     ,dcsall
c     &     ,(dcsloop+dcssoft)/dcstree !percent against born
     &     ,dcsloop2
      else
      print 112
     &     ,setsqrtsman
     &     ,setcost
     &     ,dcstree
     &     ,dcsloop
     &     ,dcssoft
     &     ,dcsall
c     &     ,(dcsloop+dcssoft)/dcstree !percent against born
     &     ,dcsloop2
      write (myunit,fmt=112)
     &     ,setsqrtsman
     &     ,setcost
     &     ,dcstree
     &     ,dcsloop
     &     ,dcssoft
     &     ,dcsall
c     &     ,(dcsloop+dcssoft)/dcstree !percent against born
     &     ,dcsloop2
      endif

        enddo                   !for the cost variable loop
        lheader=.true.
C----------------------------------------------------------------------
C CALL OF THE INTEGRATED CROSS SECTION SUBROUTINE
        if ((.NOT.lprintics).AND.(.NOT.lprintfba)) goto 5
 2      call ICS(setsqrtsman,setfracomega,setlimcost
     &       ,icstot,icsfba,errtot,errfba)
 3      if (.NOT.lprintics) goto 4
C----------------------------------------------------------------------
c PRINTOUT OF THE ICS     
        if (lheader) call SIGNATURE(myunit,commentchar,2,llongoutput)

        print 114
     &       ,setsqrtsman
     &       ,setlimcost
     &       ,icstot(1)
     &       ,icstot(2)
     &       ,icstot(3)
     &       ,icstot(1)+icstot(2)+icstot(3)
     &       ,icstot(4)
     &       ,errtot(1)
     &       ,errtot(2)
     &       ,errtot(3)
     &       ,errtot(1)+errtot(2)+errtot(3)
     &       ,errtot(4)
        write (myunit,fmt=114)
     &       ,setsqrtsman
     &       ,setlimcost
     &       ,icstot(1)
     &       ,icstot(2)
     &       ,icstot(3)
     &       ,icstot(1)+icstot(2)+icstot(3)
     &       ,icstot(4)
     &       ,errtot(1)
     &       ,errtot(2)
     &       ,errtot(3)
     &       ,errtot(1)+errtot(2)+errtot(3)
     &       ,errtot(4)
 4      continue
        if (.NOT.lprintfba) goto 5

        if (lheader) call SIGNATURE(myunit,commentchar,3,llongoutput)
        print 114
     &       ,setsqrtsman
     &       ,setlimcost
     &       ,icsfba(1)/icstot(1)
     &       ,icsfba(2)/icstot(1)
     &       ,icsfba(3)/icstot(1)
     &       ,(icsfba(1)+icsfba(2)+icsfba(3))/
     &       (icstot(1)+icstot(2)+icstot(3))
     &       ,icsfba(4)/icstot(4)
     &       ,errfba(1)/icstot(1)
     &       ,errfba(2)/icstot(1)
     &       ,errfba(3)/icstot(1)
     &       ,(errfba(1)+errfba(2)+errfba(3))/
     &       (icstot(1)+icstot(2)+icstot(3))
     &       ,errfba(4)/icstot(4)
        write (myunit,fmt=114)
     &       ,setsqrtsman
     &       ,setlimcost
     &       ,icsfba(1)/icstot(1)
     &       ,icsfba(2)/icstot(1)
     &       ,icsfba(3)/icstot(1)
     &       ,(icsfba(1)+icsfba(2)+icsfba(3))/
     &       (icstot(1)+icstot(2)+icstot(3))
     &       ,icsfba(4)/icstot(4)
     &       ,errfba(1)/icstot(1)
     &       ,errfba(2)/icstot(1)
     &       ,errfba(3)/icstot(1)
     &       ,(errfba(1)+errfba(2)+errfba(3))/
     &       (icstot(1)+icstot(2)+icstot(3))
     &       ,errfba(4)/icstot(4)

 5      continue
        lheader=.false.
C----------------------------------------------------------------------
      enddo                     !for the sqrtsman variable loop
C----------------------------------------------------------------------
      call SIGNATURE(myunit,commentchar,10,llongoutput)
      write (myunit,fmt=105),commentchar
     &     ,'Energy given in GeV, Cross sections in pb, setfracomega='
     &     ,setfracomega
      print 105,' '
     &     ,'Energy given in GeV, Cross sections in pb, setfracomega='
     &     ,setfracomega
C----------------------------------------------------------------------
C Formatting and go
 102  format (1X,E13.7,1X,F9.7,5(1X,E21.15))
 104  format (1X,E13.7,1X,F9.7,5(1X,E13.7),3X,5(1X,E8.2))
 105  format (A1,A56,1X,F9.7)
 112  format (1X,E13.7,1X,F9.7,5(1X,E13.7))
 114  format (1X,E13.7,1X,F9.7,5(1X,E13.7),3X,5(1X,E8.2))
C----------------------------------------------------------------------
      close(myunit)
      end

C $Id: main.f,v 1.13 2004/10/13 15:31:54 alorca Exp $
