C File <c0w.F> containing the B0 function for finite width
C This file is part of aITALC
C Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
C-----------------------------------------------------------------------
      double complex function B0w(index,
     &     P1S, !external momenta
     &     cM1S,cM2S)
C-----------------------------------------------------------------------
      implicit none
      integer index
      double precision P1S
      double complex cM1S,cM2S
      double complex B0i,A0w
      double complex B0w_ff,B0wbb0,B0wbb(4)
      double precision IG1

      integer i
      double precision widthalltogether,minmass

      logical
     &     lrenorm,        !renormalization flag .true./.false.
     &     lwidth,         !propagator's widths .true./.false.
     &     lidentCKM,      !Identity for CKM matrix .true./.false. 
     &     luvcheck,       !UV-check flag
     &     lircheck        !IR-check flag
      common /lflags/ lrenorm,lwidth,lidentCKM,luvcheck,lircheck
#include <variablelist.hf>
C-----------------------------------------------------------------------
*JUST to remember what index is related with which function, added bb's
*#define aa0 1

*#define bb0 1
*#define bb1 2
*#define bb00 3
*#define bb11 4
C-----------------------------------------------------------------------
C If we don't deal with a finite width, lets call looptools
      widthalltogether=IMAG(cM1S+cM2S)
      minmass=DBLE(cM1S)
      if (DBLE(cM2S).LT.minmass) minmass=DBLE(cM2S)
      if (.NOT.lwidth) then
 10     B0w=B0i(index,P1S,DBLE(cM1S),DBLE(cM2S))
        return
c      elseif ((widthalltogether.EQ.0d0).OR.(minmass.GT.0d0)) then
c        goto 10
c      elseif (P1S.LT.0d0) then
c        goto 10
      endif
C-----------------------------------------------------------------------
C Normal computation for B_0
c      B0wbb(1)=B0wbb0(P1S,cM1S,cM2S)
      B0wbb(1)=B0w_ff(P1S,cM1S,cM2S)
C-----------------------------------------------------------------------
C Now that C0w has been calculated we specify the case
      if (P1S.NE.0d0) then
        IG1 = IGram1(P1S)
      else
        IG1 = 1d100
      endif
C-----------------------------------------------------------------------
C This does not contain multiplicative factor 1/18
      B0wbb(2) = + IG1 * ( A0w(1,cM1S) - A0w(1,cM2S) )
      B0wbb(2) = B0wbb(2) + B0wbb(1)*IG1 * (  - cM1S + cM2S )
      B0wbb(2) = B0wbb(2) + B0wbb(1)*IG1 * (  - P1S )
C-----------------------------------------------------------------------
C If IG1*cM2s is very big, the loose of accuracy is high, leading to
C crazy results on the unphysical limit
      B0wbb(3) = + B0wbb(1) * ( 6*cM1S )
      B0wbb(3) = B0wbb(3) + B0wbb(2) * ( 3*P1S + 3*cM1S - 3*cM2S )
      B0wbb(3) = B0wbb(3) - P1S + 3*cM1S + 3*cM2S + 3*A0w(1,cM2S)
      B0wbb(3) = B0wbb(3)/18
      
      B0wbb(4) = + IG1 * ( 2*P1S - 6*cM1S - 6*cM2S + 12*A0w(1,cM2S) )
      B0wbb(4) = B0wbb(4) + B0wbb(1)*IG1 * (  - 12*cM1S )
      B0wbb(4) = B0wbb(4) + B0wbb(2)*IG1 * (  - 24*P1S - 24*cM1S + 24
     &     *cM2S)
      B0wbb(4) = B0wbb(4)/18
C-----------------------------------------------------------------------
      do i=1,4
        if (index.EQ.i) B0w=B0wbb(i)
      enddo
C-----------------------------------------------------------------------
      return
      end

C***********************************************************************

      double complex function B0i(index,P1S,M1S,M2S)

      implicit none
      integer index
      double precision P1S,M1S,M2S
      double complex B0,B1,B00,B11
C-----------------------------------------------------------------------
      if (index.EQ.1) then
        B0i=B0(P1S,M1S,M2S)
      elseif (index.EQ.2) then
        B0i=B1(P1S,M1S,M2S)
      elseif (index.EQ.3) then
        B0i=B00(P1S,M1S,M2S)
      elseif (index.EQ.4) then    
        B0i=B11(P1S,M1S,M2S)
      else
        print *,'B0i: Wrong index'
      endif
C-----------------------------------------------------------------------
      return
      end
CC $Id: b0w.F,v 1.4 2004/10/14 11:27:27 alorca Exp $
