C File <d0w.F> containing the D0 function for finite width
C This file is part of aITALC
C Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
C-----------------------------------------------------------------------
      double complex function D0j(index,
     &     P1S,P2S,P3S,P4S,P1P2S,P2P3S, !external momenta
     &     M1S,M2S,M3S,M4S)     !complex masses
C-----------------------------------------------------------------------
      implicit none
      integer index
      double precision P1S,P2S,P3S,P4S,P1P2S,P2P3S
      double precision M1S,M2S,M3S,M4S

      double complex D0i,C0j,B0i,A0i
      double complex D0idd0,D0idd(11)
      double precision IG3,IG2
      integer i
      double precision widthalltogether,minmass

      logical
     &     lrenorm,        !renormalization flag .true./.false.
     &     lwidth,         !propagator's widths .true./.false.
     &     lidentCKM,      !Identity for CKM matrix .true./.false. 
     &     luvcheck,       !UV-check flag
     &     lircheck        !IR-check flag
      common /lflags/ lrenorm,lwidth,lidentCKM,luvcheck,lircheck
#include <variablelist.hf>
C-----------------------------------------------------------------------
*JUST to remember what index is related with which function
*#define dd0 1
*#define dd1 2
*#define dd2 3
*#define dd3 4
*#define dd00 5
*#define dd11 6
*#define dd12 7
*#define dd13 8
*#define dd22 9
*#define dd23 10
*#define dd33 11
*#define dd001 12
*#define dd002 13
*#define dd003 14
*#define dd111 15
*#define dd112 16
*#define dd113 17
*#define dd122 18
*#define dd123 19
*#define dd133 20
*#define dd222 21
C-----------------------------------------------------------------------
C Just for testing against the normal result
C Test de la vaca flaca
c      M3S=DCMPLX(DBLE(M3S),DIMAG(M3S)/10000000)
C-----------------------------------------------------------------------
C Normal computation for D_0
      D0idd(1)= D0i(1,P1S,P2S,P3S,P4S,P1P2S,P2P3S,M1S,M2S,M3S,M4S)
      print *,'D0idd(1)=',D0idd(1),M1S,M2S,M3S,M4S
C-----------------------------------------------------------------------
C Now that D0w has been calculated we specify the case

      IG3 = IGram3(P4S,P2P3S,P2S,P1P2S,P1S,P3S)

      D0idd(2) = DCMPLX(0)
     &     + C0j(1,P1S,P2S,P1P2S,M1S,M2S,M3S)*IG3 * (  - P1S*P3S + P1S
     &     *P4S - P1S*P1P2S + P2S*P3S - P2S*P4S - P2S*P1P2S - P3S*P1P2S-
     &     P4S*P1P2S + 2*P1P2S*P2P3S + P1P2S**2 )
      D0idd(2) = D0idd(2) 
     &     + C0j(1,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * ( 2
     &     *P1S*P3S - P2S*P3S - P2S*P4S + P2S*P1P2S - P3S*P4S - P3S
     &     *P1P2S- P3S*P2P3S + P3S**2 + P4S*P2P3S - P1P2S*P2P3S )
      D0idd(2) = D0idd(2) 
     &     + C0j(1,P4S,P2P3S,P1S,M1S,M4S,M2S)*IG3 * (
     &     -P1S*P3S - P1S*P4S + P1S*P1P2S + 2*P2S*P4S - P3S*P4S + P3S
     &     *P2P3S - P4S*P1P2S - P4S*P2P3S + P4S**2 - P1P2S*P2P3S )
      D0idd(2) = D0idd(2) 
     &     + C0j(1,P1P2S,P3S,P4S,M1S,M3S,M4S)*IG3 * ( 2
     &     *P3S*P4S + 2*P3S*P1P2S - P3S**2 + 2*P4S*P1P2S - P4S**2 -P1P2S
     &     **2 )
      D0idd(2) = D0idd(2) 
     &     + D0idd(1)*IG3 * (  - P1S*P3S*P4S - P1S*P3S
     &     *P1P2S+ 2*P1S*P3S*M1S - P1S*P3S*M3S - P1S*P3S*M4S + P1S*P3S
     &     **2 -P1S*P4S*M3S + P1S*P4S*M4S + P1S*P1P2S*M3S - P1S*P1P2S
     &     *M4S -P2S*P3S*P4S - P2S*P3S*M1S + P2S*P3S*M4S - P2S*P4S*P1P2S
     &     - P2S*P4S*M1S + 2*P2S*P4S*M3S - P2S*P4S*M4S + P2S*P4S**2 +
     &     P2S*P1P2S*M1S - P2S*P1P2S*M4S + 2*P3S*P4S*P1P2S - P3S*P4S*M1S
     &     + 2*P3S*P4S*M2S - P3S*P4S*M3S - P3S*P1P2S*P2P3S - P3S*P1P2S
     &     *M1S+ 2*P3S*P1P2S*M2S - P3S*P1P2S*M4S - P3S*P2P3S*M1S + P3S
     &     *P2P3S*M3S + P3S**2*M1S - P3S**2*M2S - P4S*P1P2S*P2P3S + 2
     &     *P4S*P1P2S*M2S - P4S*P1P2S*M3S - P4S*P1P2S*M4S + P4S*P2P3S
     &     *M1S -P4S*P2P3S*M3S - P4S**2*M2S + P4S**2*M3S - P1P2S*P2P3S
     &     *M1S -P1P2S*P2P3S*M3S + 2*P1P2S*P2P3S*M4S + P1P2S**2*P2P3S
     &     -P1P2S**2*M2S + P1P2S**2*M4S )
      D0idd(2) = D0idd(2)/4
      
      D0idd(3) =
     &     + C0j(1,P1S,P2S,P1P2S,M1S,M2S,M3S)*IG3 * (  - P1S*P2S + 2
     &     *P1S*P3S - P1S*P4S - P1S*P1P2S - P1S*P2P3S + P1S**2 - P2S*P4S
     &     +P2S*P2P3S + P4S*P1P2S - P1P2S*P2P3S )
      D0idd(3) = D0idd(3) + C0j(1,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (
     &     P1S*P2S - P1S*P3S - P1S*P2P3S - P2S*P4S - P2S*P2P3S + P3S*P4S
     &     -P3S*P2P3S - P4S*P2P3S + 2*P1P2S*P2P3S + P2P3S**2 )
      D0idd(3) = D0idd(3) + C0j(1,P4S,P2P3S,P1S,M1S,M4S,M2S)*IG3 * ( 2
     &     *P1S*P4S + 2*P1S*P2P3S - P1S**2 + 2*P4S*P2P3S - P4S**2 -P2P3S
     &     **2 )
      D0idd(3) = D0idd(3) + C0j(1,P1P2S,P3S,P4S,M1S,M3S,M4S)*IG3 * (
     &     -P1S*P3S - P1S*P4S + P1S*P1P2S + 2*P2S*P4S - P3S*P4S + P3S
     &     *P2P3S - P4S*P1P2S - P4S*P2P3S + P4S**2 - P1P2S*P2P3S )
      D0idd(3) = D0idd(3) + D0idd(1)*IG3 * (  - P1S*P2S*P4S + P1S*P2S
     &     *M1S- P1S*P2S*M4S - P1S*P3S*P4S - P1S*P3S*P2P3S - P1S*P3S*M1S
     &     -P1S*P3S*M2S + 2*P1S*P3S*M4S + 2*P1S*P4S*P2P3S - P1S*P4S*M2S+
     &     2*P1S*P4S*M3S - P1S*P4S*M4S - P1S*P1P2S*P2P3S + P1S*P1P2S*M2S
     &     - P1S*P1P2S*M4S - P1S*P2P3S*M1S + 2*P1S*P2P3S*M3S - P1S*P2P3S
     &     *M4S + P1S**2*P3S - P1S**2*M3S + P1S**2*M4S - P2S*P4S*P2P3S -
     &     P2S*P4S*M1S + 2*P2S*P4S*M2S - P2S*P4S*M4S + P2S*P4S**2 - P2S
     &     *P2P3S*M1S + P2S*P2P3S*M4S + P3S*P4S*M1S - P3S*P4S*M2S - P3S
     &     *P2P3S*M1S + P3S*P2P3S*M2S - P4S*P1P2S*P2P3S -P4S*P1P2S*M2S +
     &     P4S*P1P2S*M4S - P4S*P2P3S*M1S - P4S*P2P3S*M2S+ 2*P4S*P2P3S
     &     *M3S + P4S**2*M2S - P4S**2*M3S + 2*P1P2S*P2P3S*M1S - P1P2S
     &     *P2P3S*M2S - P1P2S*P2P3S*M4S + P1P2S*P2P3S**2 +P2P3S**2*M1S -
     &     P2P3S**2*M3S )
      D0idd(3) = D0idd(3)/4

      D0idd(4) =
     &     + C0j(1,P1S,P2S,P1P2S,M1S,M2S,M3S)*IG3 * ( 2*P1S*P2S + 2
     &     *P1S*P1P2S - P1S**2 + 2*P2S*P1P2S - P2S**2 - P1P2S**2 )
      D0idd(4) = D0idd(4) + C0j(1,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (
     &     -P1S*P2S - P1S*P3S + P1S*P2P3S - P2S*P3S + 2*P2S*P4S - P2S
     &     *P1P2S - P2S*P2P3S + P2S**2 + P3S*P1P2S - P1P2S*P2P3S )
      D0idd(4) = D0idd(4) + C0j(1,P4S,P2P3S,P1S,M1S,M4S,M2S)*IG3 * (
     &     -P1S*P2S + 2*P1S*P3S - P1S*P4S - P1S*P1P2S - P1S*P2P3S +P1S
     &     **2 - P2S*P4S + P2S*P2P3S + P4S*P1P2S - P1P2S*P2P3S )
      D0idd(4) = D0idd(4) + C0j(1,P1P2S,P3S,P4S,M1S,M3S,M4S)*IG3 * (
     &     -P1S*P3S + P1S*P4S - P1S*P1P2S + P2S*P3S - P2S*P4S - P2S
     &     *P1P2S- P3S*P1P2S - P4S*P1P2S + 2*P1P2S*P2P3S + P1P2S**2 )
      D0idd(4) = D0idd(4) + D0idd(1)*IG3 * (  - P1S*P2S*P3S - P1S*P2S
     &     *P4S+ 2*P1S*P2S*P1P2S - P1S*P2S*M1S - P1S*P2S*M3S + 2*P1S*P2S
     &     *M4S - P1S*P3S*P1P2S - P1S*P3S*M1S - P1S*P3S*M2S + 2*P1S*P3S
     &     *M3S + P1S*P4S*M2S - P1S*P4S*M3S - P1S*P1P2S*P2P3S - P1S
     &     *P1P2S*M2S - P1S*P1P2S*M3S + 2*P1S*P1P2S*M4S + P1S*P2P3S*M1S
     &     - P1S*P2P3S*M3S + P1S**2*P3S + P1S**2*M3S - P1S**2*M4S - P2S
     &     *P3S*M1S + P2S*P3S*M2S - P2S*P4S*P1P2S + 2*P2S*P4S*M1S - P2S
     &     *P4S*M2S - P2S*P4S*M3S - P2S*P1P2S*P2P3S - P2S*P1P2S*M1S -
     &     P2S*P1P2S*M2S + 2*P2S*P1P2S*M4S - P2S*P2P3S*M1S + P2S*P2P3S
     &     *M3S+ P2S**2*P4S + P2S**2*M1S - P2S**2*M4S + P3S*P1P2S*M1S -
     &     P3S*P1P2S*M2S - P4S*P1P2S*M2S + P4S*P1P2S*M3S - P1P2S*P2P3S
     &     *M1S+ 2*P1P2S*P2P3S*M2S - P1P2S*P2P3S*M3S + P1P2S**2*P2P3S
     &     +P1P2S**2*M2S - P1P2S**2*M4S )
      D0idd(4) = D0idd(4)/4
C-----------------------------------------------------------------------

      D0idd(5) = + C0j(1,P2S,P3S,P2P3S,M2S,M3S,M4S) * ( 2 )
      D0idd(5) = D0idd(5) + D0idd(1) * ( 4*M1S )
      D0idd(5) = D0idd(5) + D0idd(2) * ( 2*P1S + 2*M1S - 2*M2S )
      D0idd(5) = D0idd(5) + D0idd(3) * ( 2*P1P2S + 2*M1S - 2*M3S )
      D0idd(5) = D0idd(5) + D0idd(4) * ( 2*P4S + 2*M1S - 2*M4S )
      D0idd(5) = D0idd(5)/4

      D0idd(6) =
     &     + C0j(1,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (  - 2*P1S*P3S +
     &     P2S*P3S + P2S*P4S - P2S*P1P2S - P3S*P4S - P3S*P1P2S + P3S
     &     *P2P3S- 2*P4S*P1P2S - P4S*P2P3S + P4S**2 + P1P2S*P2P3S +
     &     P1P2S**2)
      D0idd(6) = D0idd(6) + C0j(2,P1S,P2S,P1P2S,M1S,M2S,M3S)*IG3 * (
     &     -P1S*P3S + P1S*P4S - P1S*P1P2S + P2S*P3S - P2S*P4S - P2S
     &     *P1P2S- P3S*P1P2S - P4S*P1P2S + 2*P1P2S*P2P3S + P1P2S**2 )
      D0idd(6) = D0idd(6) + C0j(2,P1S,P2P3S,P4S,M1S,M2S,M4S)*IG3 * (
     &     -P1S*P3S - P1S*P4S + P1S*P1P2S + 2*P2S*P4S - P3S*P4S + P3S
     &     *P2P3S - P4S*P1P2S - P4S*P2P3S + P4S**2 - P1P2S*P2P3S )
      D0idd(6) = D0idd(6) + C0j(2,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (
     &     - 2*P1S*P3S + P2S*P3S + P2S*P4S - P2S*P1P2S + P3S*P4S + P3S
     &     *P1P2S + P3S*P2P3S - P3S**2 - P4S*P2P3S + P1P2S*P2P3S )
      D0idd(6) = D0idd(6) + C0j(3,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (
     &     - 2*P1S*P3S + P2S*P3S + P2S*P4S - P2S*P1P2S + P3S*P4S + P3S
     &     *P1P2S + P3S*P2P3S - P3S**2 - P4S*P2P3S + P1P2S*P2P3S )
      D0idd(6) = D0idd(6) + D0idd(1)*IG3 * (  - 4*P3S*P4S*M1S - 4*P3S
     &     *P1P2S*M1S + 2*P3S**2*M1S - 4*P4S*P1P2S*M1S + 2*P4S**2*M1S +
     &     2*P1P2S**2*M1S )
      D0idd(6) = D0idd(6) + D0idd(2)*IG3 * (  - 3*P1S*P3S*P4S - 3*P1S
     &     *P3S*P1P2S + 2*P1S*P3S*M1S - P1S*P3S*M3S - P1S*P3S*M4S + 2
     &     *P1S*P3S**2 - 2*P1S*P4S*P1P2S - P1S*P4S*M3S + P1S*P4S*M4S +
     &     P1S*P4S**2 + P1S*P1P2S*M3S - P1S*P1P2S*M4S + P1S*P1P2S**2 -
     &     P2S*P3S*P4S - P2S*P3S*M1S + P2S*P3S*M4S - P2S*P4S*P1P2S - P2S
     &     *P4S*M1S + 2*P2S*P4S*M3S - P2S*P4S*M4S + P2S*P4S**2 + P2S
     &     *P1P2S*M1S - P2S*P1P2S*M4S + 2*P3S*P4S*P1P2S - 3*P3S*P4S*M1S
     &     + 4*P3S*P4S*M2S - P3S*P4S*M3S - P3S*P1P2S*P2P3S - 3*P3S*P1P2S
     &     *M1S +4*P3S*P1P2S*M2S - P3S*P1P2S*M4S - P3S*P2P3S*M1S + P3S
     &     *P2P3S*M3S + 2*P3S**2*M1S - 2*P3S**2*M2S - P4S*P1P2S*P2P3S -
     &     2*P4S*P1P2S*M1S + 4*P4S*P1P2S*M2S - P4S*P1P2S*M3S - P4S*P1P2S
     &     *M4S+ P4S*P2P3S*M1S - P4S*P2P3S*M3S + P4S**2*M1S - 2*P4S**2
     &     *M2S+ P4S**2*M3S - P1P2S*P2P3S*M1S - P1P2S*P2P3S*M3S + 2
     &     *P1P2S*P2P3S*M4S + P1P2S**2*P2P3S + P1P2S**2*M1S - 2*P1P2S**2
     &     *M2S +P1P2S**2*M4S )
      D0idd(6) = D0idd(6) + D0idd(3)*IG3 * (  - 2*P3S*P4S*P1P2S - 2*P3S
     &     *P4S*M1S + 2*P3S*P4S*M3S - 2*P3S*P1P2S*M1S + 2*P3S*P1P2S*M3S
     &     - 2*P3S*P1P2S**2 + P3S**2*P1P2S + P3S**2*M1S - P3S**2*M3S - 2
     &     *P4S*P1P2S*M1S + 2*P4S*P1P2S*M3S - 2*P4S*P1P2S**2 + P4S**2
     &     *P1P2S+ P4S**2*M1S - P4S**2*M3S + P1P2S**2*M1S - P1P2S**2*M3S
     &     +P1P2S**3 )
      D0idd(6) = D0idd(6) + D0idd(4)*IG3 * (  - 2*P3S*P4S*P1P2S - 2*P3S
     &     *P4S*M1S + 2*P3S*P4S*M4S - 2*P3S*P4S**2 - 2*P3S*P1P2S*M1S + 2
     &     *P3S*P1P2S*M4S + P3S**2*P4S + P3S**2*M1S - P3S**2*M4S - 2*P4S
     &     *P1P2S*M1S + 2*P4S*P1P2S*M4S + P4S*P1P2S**2 - 2*P4S**2*P1P2S+
     &     P4S**2*M1S - P4S**2*M4S + P4S**3 + P1P2S**2*M1S - P1P2S**2
     &     *M4S )
      D0idd(6) = D0idd(6)/4      

      D0idd(7) =
     &     + C0j(1,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * ( P1S*P3S + P1S
     &     *P4S- P1S*P1P2S - 2*P2S*P4S + P3S*P4S - P3S*P2P3S + P4S*P1P2S
     &     +P4S*P2P3S - P4S**2 + P1P2S*P2P3S )
      D0idd(7) = D0idd(7) + C0j(2,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * ( 2
     &     *P1S*P3S - P2S*P3S - P2S*P4S + P2S*P1P2S - P3S*P4S - P3S
     &     *P1P2S- P3S*P2P3S + P3S**2 + P4S*P2P3S - P1P2S*P2P3S )
      D0idd(7) = D0idd(7) + C0j(2,P1P2S,P3S,P4S,M1S,M3S,M4S)*IG3 * ( 2
     &     *P3S*P4S + 2*P3S*P1P2S - P3S**2 + 2*P4S*P1P2S - P4S**2 -P1P2S
     &     **2 )
      D0idd(7) = D0idd(7) + C0j(3,P1S,P2S,P1P2S,M1S,M2S,M3S)*IG3 * (
     &     -P1S*P3S + P1S*P4S - P1S*P1P2S + P2S*P3S - P2S*P4S - P2S
     &     *P1P2S- P3S*P1P2S - P4S*P1P2S + 2*P1P2S*P2P3S + P1P2S**2 )
      D0idd(7) = D0idd(7) + D0idd(1)*IG3 * ( 2*P1S*P3S*M1S + 2*P1S*P4S
     &     *M1S- 2*P1S*P1P2S*M1S - 4*P2S*P4S*M1S + 2*P3S*P4S*M1S - 2*P3S
     &     *P2P3S*M1S + 2*P4S*P1P2S*M1S + 2*P4S*P2P3S*M1S - 2*P4S**2*M1S
     &     + 2*P1P2S*P2P3S*M1S )
      D0idd(7) = D0idd(7) + D0idd(2)*IG3 * (  - 2*P1S*P2S*P4S + P1S*P3S
     &     *P4S- P1S*P3S*P2P3S + P1S*P3S*M1S - P1S*P3S*M2S + P1S*P4S
     &     *P1P2S+ P1S*P4S*P2P3S + P1S*P4S*M1S - P1S*P4S*M2S - P1S*P4S
     &     **2 +P1S*P1P2S*P2P3S - P1S*P1P2S*M1S + P1S*P1P2S*M2S + P1S**2
     &     *P3S+ P1S**2*P4S - P1S**2*P1P2S - 2*P2S*P4S*M1S + 2*P2S*P4S
     &     *M2S+ P3S*P4S*M1S - P3S*P4S*M2S - P3S*P2P3S*M1S + P3S*P2P3S
     &     *M2S+ P4S*P1P2S*M1S - P4S*P1P2S*M2S + P4S*P2P3S*M1S - P4S
     &     *P2P3S*M2S - P4S**2*M1S + P4S**2*M2S + P1P2S*P2P3S*M1S -
     &     P1P2S*P2P3S*M2S )
      D0idd(7) = D0idd(7) + D0idd(3)*IG3 * (  - P1S*P3S*P4S + 3*P1S*P3S
     &     *M1S- 2*P1S*P3S*M3S - P1S*P3S*M4S + P1S*P3S**2 + P1S*P4S
     &     *P1P2S+ P1S*P4S*M1S - 2*P1S*P4S*M3S + P1S*P4S*M4S - P1S*P1P2S
     &     *M1S+ 2*P1S*P1P2S*M3S - P1S*P1P2S*M4S - P1S*P1P2S**2 - P2S
     &     *P3S*P4S - P2S*P3S*M1S + P2S*P3S*M4S - 3*P2S*P4S*P1P2S - 3
     &     *P2S*P4S*M1S + 4*P2S*P4S*M3S - P2S*P4S*M4S + P2S*P4S**2 + P2S
     &     *P1P2S*M1S - P2S*P1P2S*M4S + 3*P3S*P4S*P1P2S + 2*P3S*P4S*M2S
     &     - 2*P3S*P4S*M3S - 2*P3S*P1P2S*P2P3S - P3S*P1P2S*M1S + 2*P3S
     &     *P1P2S*M2S - P3S*P1P2S*M4S - 2*P3S*P2P3S*M1S + 2*P3S*P2P3S
     &     *M3S +P3S**2*M1S - P3S**2*M2S + P4S*P1P2S*M1S + 2*P4S*P1P2S
     &     *M2S - 2*P4S*P1P2S*M3S - P4S*P1P2S*M4S + P4S*P1P2S**2 + 2*P4S
     &     *P2P3S*M1S - 2*P4S*P2P3S*M3S - P4S**2*P1P2S - P4S**2*M1S -
     &     P4S**2*M2S + 2*P4S**2*M3S - 2*P1P2S*P2P3S*M3S + 2*P1P2S*P2P3S
     &     *M4S +2*P1P2S**2*P2P3S - P1P2S**2*M2S + P1P2S**2*M4S )
      D0idd(7) = D0idd(7) + D0idd(4)*IG3 * ( P1S*P3S*P4S + P1S*P3S*M1S -
     &    P1S*P3S*M4S - P1S*P4S*P1P2S + P1S*P4S*M1S - P1S*P4S*M4S + P1S
     &    *P4S**2 - P1S*P1P2S*M1S + P1S*P1P2S*M4S - 2*P2S*P4S*M1S + 2*
     &    P2S*P4S*M4S - 2*P2S*P4S**2 - P3S*P4S*P2P3S + P3S*P4S*M1S -
     &    P3S*P4S*M4S + P3S*P4S**2 - P3S*P2P3S*M1S + P3S*P2P3S*M4S +
     &    P4S*P1P2S*P2P3S + P4S*P1P2S*M1S - P4S*P1P2S*M4S + P4S*P2P3S*
     &    M1S - P4S*P2P3S*M4S + P4S**2*P1P2S + P4S**2*P2P3S - P4S**2*
     &    M1S + P4S**2*M4S - P4S**3 + P1P2S*P2P3S*M1S - P1P2S*P2P3S*M4S
     &     )
      D0idd(7) = D0idd(7)/4

      D0idd(8) =
     &     + C0j(1,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * ( P1S*P3S - P1S
     &     *P4S+ P1S*P1P2S - P2S*P3S + P2S*P4S + P2S*P1P2S + P3S*P1P2S
     &     +P4S*P1P2S - 2*P1P2S*P2P3S - P1P2S**2 )
      D0idd(8) = D0idd(8) + C0j(3,P1S,P2P3S,P4S,M1S,M2S,M4S)*IG3 * (
     &     -P1S*P3S - P1S*P4S + P1S*P1P2S + 2*P2S*P4S - P3S*P4S + P3S
     &     *P2P3S - P4S*P1P2S - P4S*P2P3S + P4S**2 - P1P2S*P2P3S )
      D0idd(8) = D0idd(8) + C0j(3,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * ( 2
     &     *P1S*P3S - P2S*P3S - P2S*P4S + P2S*P1P2S - P3S*P4S - P3S
     &     *P1P2S- P3S*P2P3S + P3S**2 + P4S*P2P3S - P1P2S*P2P3S )
      D0idd(8) = D0idd(8) + C0j(3,P1P2S,P3S,P4S,M1S,M3S,M4S)*IG3 * ( 2
     &     *P3S*P4S + 2*P3S*P1P2S - P3S**2 + 2*P4S*P1P2S - P4S**2 -P1P2S
     &     **2 )
      D0idd(8) = D0idd(8) + D0idd(1)*IG3 * ( 2*P1S*P3S*M1S - 2*P1S*P4S
     &     *M1S+ 2*P1S*P1P2S*M1S - 2*P2S*P3S*M1S + 2*P2S*P4S*M1S + 2*P2S
     &     *P1P2S*M1S + 2*P3S*P1P2S*M1S + 2*P4S*P1P2S*M1S - 4*P1P2S
     &     *P2P3S*M1S - 2*P1P2S**2*M1S )
      D0idd(8) = D0idd(8) + D0idd(2)*IG3 * (  - P1S*P2S*P3S + P1S*P2S
     &     *P4S+ P1S*P2S*P1P2S + P1S*P3S*P1P2S + P1S*P3S*M1S - P1S*P3S
     &     *M2S+ P1S*P4S*P1P2S - P1S*P4S*M1S + P1S*P4S*M2S - 2*P1S*P1P2S
     &     *P2P3S + P1S*P1P2S*M1S - P1S*P1P2S*M2S - P1S*P1P2S**2 + P1S
     &     **2*P3S - P1S**2*P4S + P1S**2*P1P2S - P2S*P3S*M1S + P2S*P3S
     &     *M2S+ P2S*P4S*M1S - P2S*P4S*M2S + P2S*P1P2S*M1S - P2S*P1P2S
     &     *M2S+ P3S*P1P2S*M1S - P3S*P1P2S*M2S + P4S*P1P2S*M1S - P4S
     &     *P1P2S*M2S - 2*P1P2S*P2P3S*M1S + 2*P1P2S*P2P3S*M2S - P1P2S**2
     &     *M1S +P1P2S**2*M2S )
      D0idd(8) = D0idd(8) + D0idd(3)*IG3 * ( P1S*P3S*P1P2S + P1S*P3S*M1S
     &     -P1S*P3S*M3S - P1S*P4S*P1P2S - P1S*P4S*M1S + P1S*P4S*M3S +
     &     P1S*P1P2S*M1S - P1S*P1P2S*M3S + P1S*P1P2S**2 - P2S*P3S*P1P2S
     &     -P2S*P3S*M1S + P2S*P3S*M3S + P2S*P4S*P1P2S + P2S*P4S*M1S -
     &     P2S*P4S*M3S + P2S*P1P2S*M1S - P2S*P1P2S*M3S + P2S*P1P2S**2 +
     &     P3S*P1P2S*M1S - P3S*P1P2S*M3S + P3S*P1P2S**2 + P4S*P1P2S*M1S
     &     -P4S*P1P2S*M3S + P4S*P1P2S**2 - 2*P1P2S*P2P3S*M1S + 2*P1P2S
     &     *P2P3S*M3S - 2*P1P2S**2*P2P3S - P1P2S**2*M1S + P1P2S**2*M3S
     &     -P1P2S**3 )
      D0idd(8) = D0idd(8) + D0idd(4)*IG3 * (  - P1S*P3S*P1P2S + 3*P1S
     &     *P3S*M1S - P1S*P3S*M3S - 2*P1S*P3S*M4S + P1S*P3S**2 + P1S*P4S
     &     *P1P2S - P1S*P4S*M1S - P1S*P4S*M3S + 2*P1S*P4S*M4S - P1S*P4S
     &     **2 + P1S*P1P2S*M1S + P1S*P1P2S*M3S - 2*P1S*P1P2S*M4S - 2*P2S
     &     *P3S*P4S - 2*P2S*P3S*M1S + 2*P2S*P3S*M4S + 2*P2S*P4S*M3S- 2
     &     *P2S*P4S*M4S + 2*P2S*P4S**2 + 2*P2S*P1P2S*M1S - 2*P2S*P1P2S
     &     *M4S + 3*P3S*P4S*P1P2S - P3S*P4S*M1S + 2*P3S*P4S*M2S -P3S*P4S
     &     *M3S - P3S*P1P2S*P2P3S + 2*P3S*P1P2S*M2S - 2*P3S*P1P2S*M4S -
     &     P3S*P2P3S*M1S + P3S*P2P3S*M3S + P3S**2*M1S - P3S**2*M2S - 3
     &     *P4S*P1P2S*P2P3S + P4S*P1P2S*M1S + 2*P4S*P1P2S*M2S -P4S*P1P2S
     &     *M3S - 2*P4S*P1P2S*M4S - P4S*P1P2S**2 + P4S*P2P3S*M1S - P4S
     &     *P2P3S*M3S + P4S**2*P1P2S - P4S**2*M2S + P4S**2*M3S- 3*P1P2S
     &     *P2P3S*M1S - P1P2S*P2P3S*M3S + 4*P1P2S*P2P3S*M4S +P1P2S**2
     &     *P2P3S - P1P2S**2*M1S - P1P2S**2*M2S + 2*P1P2S**2*M4S)
      D0idd(8) = D0idd(8)/8

      D0idd(9) =
     &     + C0j(1,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (  - 2*P1S*P4S - 2
     &     *P1S*P2P3S + P1S**2 - 2*P4S*P2P3S + P4S**2 + P2P3S**2 )
      D0idd(9) = D0idd(9) + C0j(2,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (
     &     P1S*P2S - P1S*P3S - P1S*P2P3S - P2S*P4S - P2S*P2P3S + P3S*P4S
     &     -P3S*P2P3S - P4S*P2P3S + 2*P1P2S*P2P3S + P2P3S**2 )
      D0idd(9) = D0idd(9) + C0j(2,P1P2S,P3S,P4S,M1S,M3S,M4S)*IG3 * (
     &     -P1S*P3S - P1S*P4S + P1S*P1P2S + 2*P2S*P4S - P3S*P4S + P3S
     &     *P2P3S - P4S*P1P2S - P4S*P2P3S + P4S**2 - P1P2S*P2P3S )
      D0idd(9) = D0idd(9) + C0j(3,P1S,P2S,P1P2S,M1S,M2S,M3S)*IG3 * (
     &     -P1S*P2S + 2*P1S*P3S - P1S*P4S - P1S*P1P2S - P1S*P2P3S +P1S
     &     **2 - P2S*P4S + P2S*P2P3S + P4S*P1P2S - P1P2S*P2P3S )
      D0idd(9) = D0idd(9) + D0idd(1)*IG3 * (  - 4*P1S*P4S*M1S - 4*P1S
     &     *P2P3S*M1S + 2*P1S**2*M1S - 4*P4S*P2P3S*M1S + 2*P4S**2*M1S +
     &     2*P2P3S**2*M1S )
      D0idd(9) = D0idd(9) + D0idd(2)*IG3 * (  - 2*P1S*P4S*P2P3S - 2*P1S
     &     *P4S*M1S + 2*P1S*P4S*M2S + P1S*P4S**2 - 2*P1S*P2P3S*M1S + 2
     &     *P1S*P2P3S*M2S + P1S*P2P3S**2 - 2*P1S**2*P4S - 2*P1S**2*P2P3S
     &     +P1S**2*M1S - P1S**2*M2S + P1S**3 - 2*P4S*P2P3S*M1S + 2*P4S
     &     *P2P3S*M2S + P4S**2*M1S - P4S**2*M2S + P2P3S**2*M1S - P2P3S
     &     **2*M2S )
      D0idd(9) = D0idd(9) + D0idd(3)*IG3 * (  - P1S*P2S*P4S + P1S*P2S
     &     *M1S- P1S*P2S*M4S - P1S*P3S*P4S - P1S*P3S*P2P3S - P1S*P3S*M1S
     &     -P1S*P3S*M2S + 2*P1S*P3S*M4S - 2*P1S*P4S*P1P2S + 2*P1S*P4S
     &     *P2P3S - 2*P1S*P4S*M1S - P1S*P4S*M2S + 4*P1S*P4S*M3S - P1S
     &     *P4S*M4S - 3*P1S*P1P2S*P2P3S + P1S*P1P2S*M2S - P1S*P1P2S*M4S
     &     - 3*P1S*P2P3S*M1S + 4*P1S*P2P3S*M3S - P1S*P2P3S*M4S + P1S**2
     &     *P3S+ P1S**2*P1P2S + P1S**2*M1S - 2*P1S**2*M3S + P1S**2*M4S
     &     -P2S*P4S*P2P3S - P2S*P4S*M1S + 2*P2S*P4S*M2S - P2S*P4S*M4S
     &     +P2S*P4S**2 - P2S*P2P3S*M1S + P2S*P2P3S*M4S + P3S*P4S*M1S
     &     -P3S*P4S*M2S - P3S*P2P3S*M1S + P3S*P2P3S*M2S - 3*P4S*P1P2S
     &     *P2P3S - P4S*P1P2S*M2S + P4S*P1P2S*M4S - 3*P4S*P2P3S*M1S -
     &     P4S*P2P3S*M2S + 4*P4S*P2P3S*M3S + P4S**2*P1P2S + P4S**2*M1S
     &     +P4S**2*M2S - 2*P4S**2*M3S + 2*P1P2S*P2P3S*M1S - P1P2S*P2P3S
     &     *M2S - P1P2S*P2P3S*M4S + 2*P1P2S*P2P3S**2 + 2*P2P3S**2*M1S -
     &     2*P2P3S**2*M3S )
      D0idd(9) = D0idd(9) + D0idd(4)*IG3 * (  - 2*P1S*P4S*P2P3S - 2*P1S
     &     *P4S*M1S + 2*P1S*P4S*M4S - 2*P1S*P4S**2 - 2*P1S*P2P3S*M1S + 2
     &     *P1S*P2P3S*M4S + P1S**2*P4S + P1S**2*M1S - P1S**2*M4S - 2*P4S
     &     *P2P3S*M1S + 2*P4S*P2P3S*M4S + P4S*P2P3S**2 - 2*P4S**2*P2P3S+
     &     P4S**2*M1S - P4S**2*M4S + P4S**3 + P2P3S**2*M1S - P2P3S**2
     &     *M4S )
      D0idd(9) = D0idd(9)/4

      D0idd(10) =
     &     + C0j(1,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * ( P1S*P2S - 2*P1S*
     &    P3S + P1S*P4S + P1S*P1P2S + P1S*P2P3S - P1S**2 + P2S*P4S -
     &    P2S*P2P3S - P4S*P1P2S + P1P2S*P2P3S )
      D0idd(10) = D0idd(10) + C0j(3,P1S,P2P3S,P4S,M1S,M2S,M4S)*IG3 * (
     &     2*P1S*P4S + 2*P1S*P2P3S - P1S**2 + 2*P4S*P2P3S - P4S**2
     &     -P2P3S**2 )
      D0idd(10) = D0idd(10) + C0j(3,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (
     &    P1S*P2S - P1S*P3S - P1S*P2P3S - P2S*P4S - P2S*P2P3S + P3S*P4S
     &     - P3S*P2P3S - P4S*P2P3S + 2*P1P2S*P2P3S + P2P3S**2 )
      D0idd(10) = D0idd(10) + C0j(3,P1P2S,P3S,P4S,M1S,M3S,M4S)*IG3 * (
     &     - P1S*P3S - P1S*P4S + P1S*P1P2S + 2*P2S*P4S - P3S*P4S + P3S*
     &    P2P3S - P4S*P1P2S - P4S*P2P3S + P4S**2 - P1P2S*P2P3S )
      D0idd(10) = D0idd(10) + D0idd(1)*IG3 * ( 2*P1S*P2S*M1S - 4*P1S*P3S
     &     *M1S + 2*P1S*P4S*M1S + 2*P1S*P1P2S*M1S + 2*P1S*P2P3S*M1S - 2
     &     *P1S**2*M1S + 2*P2S*P4S*M1S - 2*P2S*P2P3S*M1S - 2*P4S*P1P2S
     &     *M1S + 2*P1P2S*P2P3S*M1S )
      D0idd(10) = D0idd(10) + D0idd(2)*IG3 * ( P1S*P2S*P4S - P1S*P2S
     &     *P2P3S+ P1S*P2S*M1S - P1S*P2S*M2S - 2*P1S*P3S*M1S + 2*P1S*P3S
     &     *M2S- P1S*P4S*P1P2S + P1S*P4S*M1S - P1S*P4S*M2S + P1S*P1P2S
     &     *P2P3S + P1S*P1P2S*M1S - P1S*P1P2S*M2S + P1S*P2P3S*M1S - P1S
     &     *P2P3S*M2S + P1S**2*P2S - 2*P1S**2*P3S + P1S**2*P4S + P1S**2
     &     *P1P2S + P1S**2*P2P3S - P1S**2*M1S + P1S**2*M2S - P1S**3 +
     &     P2S*P4S*M1S - P2S*P4S*M2S - P2S*P2P3S*M1S + P2S*P2P3S*M2S -
     &     P4S*P1P2S*M1S + P4S*P1P2S*M2S + P1P2S*P2P3S*M1S - P1P2S*P2P3S
     &     *M2S)
      D0idd(10) = D0idd(10) + D0idd(3)*IG3 * ( P1S*P2S*P1P2S + P1S*P2S
     &     *M1S- P1S*P2S*M3S - 2*P1S*P3S*P1P2S - 2*P1S*P3S*M1S + 2*P1S
     &     *P3S*M3S + P1S*P4S*P1P2S + P1S*P4S*M1S - P1S*P4S*M3S + P1S
     &     *P1P2S*P2P3S + P1S*P1P2S*M1S - P1S*P1P2S*M3S + P1S*P1P2S**2 +
     &     P1S*P2P3S*M1S - P1S*P2P3S*M3S - P1S**2*P1P2S - P1S**2*M1S
     &     +P1S**2*M3S + P2S*P4S*P1P2S + P2S*P4S*M1S - P2S*P4S*M3S - P2S
     &     *P1P2S*P2P3S - P2S*P2P3S*M1S + P2S*P2P3S*M3S - P4S*P1P2S*M1S+
     &     P4S*P1P2S*M3S - P4S*P1P2S**2 + P1P2S*P2P3S*M1S - P1P2S*P2P3S
     &     *M3S + P1P2S**2*P2P3S )
      D0idd(10) = D0idd(10) + D0idd(4)*IG3 * ( 2*P1S*P2S*M1S - 2*P1S*P2S
     &     *M4S - 3*P1S*P3S*P4S - P1S*P3S*P2P3S - 3*P1S*P3S*M1S - P1S
     &     *P3S*M2S + 4*P1S*P3S*M4S + P1S*P4S*P1P2S + 3*P1S*P4S*P2P3S +
     &     P1S*P4S*M1S - P1S*P4S*M2S + 2*P1S*P4S*M3S - 2*P1S*P4S*M4S +
     &     P1S*P4S**2 - P1S*P1P2S*P2P3S + P1S*P1P2S*M1S + P1S*P1P2S*M2S
     &     - 2*P1S*P1P2S*M4S + 2*P1S*P2P3S*M3S - 2*P1S*P2P3S*M4S + P1S
     &     **2*P3S - P1S**2*P4S - P1S**2*M1S - P1S**2*M3S + 2*P1S**2*M4S
     &     - 2*P2S*P4S*P2P3S + 2*P2S*P4S*M2S - 2*P2S*P4S*M4S + 2*P2S*P4S
     &     **2- 2*P2S*P2P3S*M1S + 2*P2S*P2P3S*M4S + P3S*P4S*M1S - P3S
     &     *P4S*M2S - P3S*P2P3S*M1S + P3S*P2P3S*M2S - P4S*P1P2S*M1S -
     &     P4S*P1P2S*M2S + 2*P4S*P1P2S*M4S - P4S*P2P3S*M1S - P4S*P2P3S
     &     *M2S+ 2*P4S*P2P3S*M3S - P4S**2*P1P2S + P4S**2*M2S - P4S**2
     &     *M3S+ 3*P1P2S*P2P3S*M1S - P1P2S*P2P3S*M2S - 2*P1P2S*P2P3S*M4S
     &     +P1P2S*P2P3S**2 + P2P3S**2*M1S - P2P3S**2*M3S )
      D0idd(10) = D0idd(10)/4

      D0idd(11) =
     &     + C0j(1,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (  - 2*P1S*P2S - 2
     &     *P1S*P1P2S + P1S**2 - 2*P2S*P1P2S + P2S**2 + P1P2S**2 )
      D0idd(11) = D0idd(11) + C0j(3,P1S,P2P3S,P4S,M1S,M2S,M4S)*IG3 * (
     &     - P1S*P2S + 2*P1S*P3S - P1S*P4S - P1S*P1P2S - P1S*P2P3S +
     &     P1S**2 - P2S*P4S + P2S*P2P3S + P4S*P1P2S - P1P2S*P2P3S )
      D0idd(11) = D0idd(11) + C0j(3,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (
     &     - P1S*P2S - P1S*P3S + P1S*P2P3S - P2S*P3S + 2*P2S*P4S - P2S*
     &     P1P2S - P2S*P2P3S + P2S**2 + P3S*P1P2S - P1P2S*P2P3S )
      D0idd(11) = D0idd(11) + C0j(3,P1P2S,P3S,P4S,M1S,M3S,M4S)*IG3 * (
     &     - P1S*P3S + P1S*P4S - P1S*P1P2S + P2S*P3S - P2S*P4S - P2S*
     &     P1P2S - P3S*P1P2S - P4S*P1P2S + 2*P1P2S*P2P3S + P1P2S**2 )
      D0idd(11) = D0idd(11) + D0idd(1)*IG3 * (  - 4*P1S*P2S*M1S - 4*P1S*
     &     P1P2S*M1S + 2*P1S**2*M1S - 4*P2S*P1P2S*M1S + 2*P2S**2*M1S + 2
     &     *P1P2S**2*M1S )
      D0idd(11) = D0idd(11) + D0idd(2)*IG3 * (  - 2*P1S*P2S*P1P2S - 2
     &     *P1S*P2S*M1S + 2*P1S*P2S*M2S + P1S*P2S**2 - 2*P1S*P1P2S*M1S +
     &     2*P1S*P1P2S*M2S + P1S*P1P2S**2 - 2*P1S**2*P2S - 2*P1S**2
     &     *P1P2S+ P1S**2*M1S - P1S**2*M2S + P1S**3 - 2*P2S*P1P2S*M1S +
     &     2*P2S*P1P2S*M2S + P2S**2*M1S - P2S**2*M2S + P1P2S**2*M1S
     &     -P1P2S**2*M2S )
      D0idd(11) = D0idd(11) + D0idd(3)*IG3 * (  - 2*P1S*P2S*P1P2S - 2
     &     *P1S*P2S*M1S + 2*P1S*P2S*M3S - 2*P1S*P1P2S*M1S + 2*P1S*P1P2S
     &     *M3S- 2*P1S*P1P2S**2 + P1S**2*P1P2S + P1S**2*M1S - P1S**2*M3S
     &     -2*P2S*P1P2S*M1S + 2*P2S*P1P2S*M3S - 2*P2S*P1P2S**2 + P2S**2
     &     *P1P2S + P2S**2*M1S - P2S**2*M3S + P1P2S**2*M1S - P1P2S**2
     &     *M3S+ P1P2S**3 )
      D0idd(11) = D0idd(11) + D0idd(4)*IG3 * (  - P1S*P2S*P3S - 3*P1S
     &     *P2S*P4S + 2*P1S*P2S*P1P2S - 3*P1S*P2S*M1S - P1S*P2S*M3S + 4
     &     *P1S*P2S*M4S - P1S*P3S*P1P2S - P1S*P3S*M1S - P1S*P3S*M2S + 2
     &     *P1S*P3S*M3S - 2*P1S*P4S*P1P2S + P1S*P4S*M2S - P1S*P4S*M3S -
     &     P1S*P1P2S*P2P3S - 2*P1S*P1P2S*M1S - P1S*P1P2S*M2S - P1S*P1P2S
     &     *M3S+ 4*P1S*P1P2S*M4S + P1S*P2P3S*M1S - P1S*P2P3S*M3S + P1S
     &     **2*P3S + P1S**2*P4S + P1S**2*M1S + P1S**2*M3S - 2*P1S**2*M4S
     &     -P2S*P3S*M1S + P2S*P3S*M2S - 3*P2S*P4S*P1P2S + 2*P2S*P4S*M1S-
     &     P2S*P4S*M2S - P2S*P4S*M3S - P2S*P1P2S*P2P3S - 3*P2S*P1P2S*M1S
     &     - P2S*P1P2S*M2S + 4*P2S*P1P2S*M4S - P2S*P2P3S*M1S + P2S*P2P3S
     &     *M3S + 2*P2S**2*P4S + 2*P2S**2*M1S - 2*P2S**2*M4S + P3S*P1P2S
     &     *M1S - P3S*P1P2S*M2S - P4S*P1P2S*M2S + P4S*P1P2S*M3S +P4S
     &     *P1P2S**2 - P1P2S*P2P3S*M1S + 2*P1P2S*P2P3S*M2S - P1P2S*P2P3S
     &     *M3S + P1P2S**2*P2P3S + P1P2S**2*M1S + P1P2S**2*M2S - 2*P1P2S
     &     **2*M4S )
      D0idd(11) = D0idd(11)/4      
C-----------------------------------------------------------------------
      do i=1,11
        if (index.EQ.i) D0j=D0idd(i)
*        print *,'D(',i,')=',D0idd(i)
      enddo
C-----------------------------------------------------------------------
      return
      end


CC $Id: d0j.F,v 1.1 2004/10/11 21:21:49 alorca Exp $
