C File <d0w.F> containing the D0 function for finite width
C This file is part of aITALC
C Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
C-----------------------------------------------------------------------
      double complex function D0w(index,
     &     P1S,P2S,P3S,P4S,P1P2S,P2P3S, !external momenta
     &     M1S,M2S,M3S,M4S)     !complex masses
C-----------------------------------------------------------------------
      implicit none
      integer index
      double precision P1S,P2S,P3S,P4S,P1P2S,P2P3S
      double complex M1S,M2S,M3S,M4S

      double complex D0i,C0w,B0w,A0w
      double complex D0wdd0,D0wdd(11)
      double precision IG3,IG2
      integer i
      double precision widthalltogether,minmass

      logical
     &     lrenorm,        !renormalization flag .true./.false.
     &     lwidth,         !propagator's widths .true./.false.
     &     lidentCKM,      !Identity for CKM matrix .true./.false. 
     &     luvcheck,       !UV-check flag
     &     lircheck        !IR-check flag
      common /lflags/ lrenorm,lwidth,lidentCKM,luvcheck,lircheck
#include <variablelist.hf>
C-----------------------------------------------------------------------
*JUST to remember what index is related with which function
*#define dd0 1
*#define dd1 2
*#define dd2 3
*#define dd3 4
*#define dd00 5
*#define dd11 6
*#define dd12 7
*#define dd13 8
*#define dd22 9
*#define dd23 10
*#define dd33 11
*#define dd001 12
*#define dd002 13
*#define dd003 14
*#define dd111 15
*#define dd112 16
*#define dd113 17
*#define dd122 18
*#define dd123 19
*#define dd133 20
*#define dd222 21
C-----------------------------------------------------------------------
C If we don't deal with a finite width, let's call looptools
      widthalltogether=IMAG(M1S+M2S+M3S+M4S)
      minmass=DBLE(M1S)
      if (DBLE(M2S).LT.minmass) minmass=DBLE(M2S)
      if (DBLE(M3S).LT.minmass) minmass=DBLE(M3S)
      if (DBLE(M4S).LT.minmass) minmass=DBLE(M4S)

      if ((.NOT.lwidth).OR.(widthalltogether.EQ.0d0).OR.(minmass.GT.0d0)
     &     ) then
 10     D0w=D0i(index,P1S,P2S,P3S,P4S,P1P2S,P2P3S,
     &       DBLE(M1S),DBLE(M2S),DBLE(M3S),DBLE(M4S))
        return
      endif
C-----------------------------------------------------------------------
C Just for testing against the normal result
C Test de la vaca flaca
c      M3S=DCMPLX(DBLE(M3S),IMAG(M3S)/10000000)
C-----------------------------------------------------------------------
C Normal computation for D_0
      D0wdd(1)= D0wdd0(P1S,P2S,P3S,P4S,P1P2S,P2P3S,M1S,M2S,M3S,M4S)
C-----------------------------------------------------------------------
C Now that D0w has been calculated we specify the case

      IG3 = IGram3(P4S,P2P3S,P2S,P1P2S,P1S,P3S)

      D0wdd(2) = DCMPLX(0)
     &     + C0w(1,P1S,P2S,P1P2S,M1S,M2S,M3S)*IG3 * (  - P1S*P3S + P1S
     &     *P4S - P1S*P1P2S + P2S*P3S - P2S*P4S - P2S*P1P2S - P3S*P1P2S-
     &     P4S*P1P2S + 2*P1P2S*P2P3S + P1P2S**2 )
      D0wdd(2) = D0wdd(2) 
     &     + C0w(1,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * ( 2
     &     *P1S*P3S - P2S*P3S - P2S*P4S + P2S*P1P2S - P3S*P4S - P3S
     &     *P1P2S- P3S*P2P3S + P3S**2 + P4S*P2P3S - P1P2S*P2P3S )
      D0wdd(2) = D0wdd(2) 
     &     + C0w(1,P4S,P2P3S,P1S,M1S,M4S,M2S)*IG3 * (
     &     -P1S*P3S - P1S*P4S + P1S*P1P2S + 2*P2S*P4S - P3S*P4S + P3S
     &     *P2P3S - P4S*P1P2S - P4S*P2P3S + P4S**2 - P1P2S*P2P3S )
      D0wdd(2) = D0wdd(2) 
     &     + C0w(1,P1P2S,P3S,P4S,M1S,M3S,M4S)*IG3 * ( 2
     &     *P3S*P4S + 2*P3S*P1P2S - P3S**2 + 2*P4S*P1P2S - P4S**2 -P1P2S
     &     **2 )
      D0wdd(2) = D0wdd(2) 
     &     + D0wdd(1)*IG3 * (  - P1S*P3S*P4S - P1S*P3S
     &     *P1P2S+ 2*P1S*P3S*M1S - P1S*P3S*M3S - P1S*P3S*M4S + P1S*P3S
     &     **2 -P1S*P4S*M3S + P1S*P4S*M4S + P1S*P1P2S*M3S - P1S*P1P2S
     &     *M4S -P2S*P3S*P4S - P2S*P3S*M1S + P2S*P3S*M4S - P2S*P4S*P1P2S
     &     - P2S*P4S*M1S + 2*P2S*P4S*M3S - P2S*P4S*M4S + P2S*P4S**2 +
     &     P2S*P1P2S*M1S - P2S*P1P2S*M4S + 2*P3S*P4S*P1P2S - P3S*P4S*M1S
     &     + 2*P3S*P4S*M2S - P3S*P4S*M3S - P3S*P1P2S*P2P3S - P3S*P1P2S
     &     *M1S+ 2*P3S*P1P2S*M2S - P3S*P1P2S*M4S - P3S*P2P3S*M1S + P3S
     &     *P2P3S*M3S + P3S**2*M1S - P3S**2*M2S - P4S*P1P2S*P2P3S + 2
     &     *P4S*P1P2S*M2S - P4S*P1P2S*M3S - P4S*P1P2S*M4S + P4S*P2P3S
     &     *M1S -P4S*P2P3S*M3S - P4S**2*M2S + P4S**2*M3S - P1P2S*P2P3S
     &     *M1S -P1P2S*P2P3S*M3S + 2*P1P2S*P2P3S*M4S + P1P2S**2*P2P3S
     &     -P1P2S**2*M2S + P1P2S**2*M4S )
      D0wdd(2) = D0wdd(2)/4
      
      D0wdd(3) =
     &     + C0w(1,P1S,P2S,P1P2S,M1S,M2S,M3S)*IG3 * (  - P1S*P2S + 2
     &     *P1S*P3S - P1S*P4S - P1S*P1P2S - P1S*P2P3S + P1S**2 - P2S*P4S
     &     +P2S*P2P3S + P4S*P1P2S - P1P2S*P2P3S )
      D0wdd(3) = D0wdd(3) + C0w(1,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (
     &     P1S*P2S - P1S*P3S - P1S*P2P3S - P2S*P4S - P2S*P2P3S + P3S*P4S
     &     -P3S*P2P3S - P4S*P2P3S + 2*P1P2S*P2P3S + P2P3S**2 )
      D0wdd(3) = D0wdd(3) + C0w(1,P4S,P2P3S,P1S,M1S,M4S,M2S)*IG3 * ( 2
     &     *P1S*P4S + 2*P1S*P2P3S - P1S**2 + 2*P4S*P2P3S - P4S**2 -P2P3S
     &     **2 )
      D0wdd(3) = D0wdd(3) + C0w(1,P1P2S,P3S,P4S,M1S,M3S,M4S)*IG3 * (
     &     -P1S*P3S - P1S*P4S + P1S*P1P2S + 2*P2S*P4S - P3S*P4S + P3S
     &     *P2P3S - P4S*P1P2S - P4S*P2P3S + P4S**2 - P1P2S*P2P3S )
      D0wdd(3) = D0wdd(3) + D0wdd(1)*IG3 * (  - P1S*P2S*P4S + P1S*P2S
     &     *M1S- P1S*P2S*M4S - P1S*P3S*P4S - P1S*P3S*P2P3S - P1S*P3S*M1S
     &     -P1S*P3S*M2S + 2*P1S*P3S*M4S + 2*P1S*P4S*P2P3S - P1S*P4S*M2S+
     &     2*P1S*P4S*M3S - P1S*P4S*M4S - P1S*P1P2S*P2P3S + P1S*P1P2S*M2S
     &     - P1S*P1P2S*M4S - P1S*P2P3S*M1S + 2*P1S*P2P3S*M3S - P1S*P2P3S
     &     *M4S + P1S**2*P3S - P1S**2*M3S + P1S**2*M4S - P2S*P4S*P2P3S -
     &     P2S*P4S*M1S + 2*P2S*P4S*M2S - P2S*P4S*M4S + P2S*P4S**2 - P2S
     &     *P2P3S*M1S + P2S*P2P3S*M4S + P3S*P4S*M1S - P3S*P4S*M2S - P3S
     &     *P2P3S*M1S + P3S*P2P3S*M2S - P4S*P1P2S*P2P3S -P4S*P1P2S*M2S +
     &     P4S*P1P2S*M4S - P4S*P2P3S*M1S - P4S*P2P3S*M2S+ 2*P4S*P2P3S
     &     *M3S + P4S**2*M2S - P4S**2*M3S + 2*P1P2S*P2P3S*M1S - P1P2S
     &     *P2P3S*M2S - P1P2S*P2P3S*M4S + P1P2S*P2P3S**2 +P2P3S**2*M1S -
     &     P2P3S**2*M3S )
      D0wdd(3) = D0wdd(3)/4

      D0wdd(4) =
     &     + C0w(1,P1S,P2S,P1P2S,M1S,M2S,M3S)*IG3 * ( 2*P1S*P2S + 2
     &     *P1S*P1P2S - P1S**2 + 2*P2S*P1P2S - P2S**2 - P1P2S**2 )
      D0wdd(4) = D0wdd(4) + C0w(1,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (
     &     -P1S*P2S - P1S*P3S + P1S*P2P3S - P2S*P3S + 2*P2S*P4S - P2S
     &     *P1P2S - P2S*P2P3S + P2S**2 + P3S*P1P2S - P1P2S*P2P3S )
      D0wdd(4) = D0wdd(4) + C0w(1,P4S,P2P3S,P1S,M1S,M4S,M2S)*IG3 * (
     &     -P1S*P2S + 2*P1S*P3S - P1S*P4S - P1S*P1P2S - P1S*P2P3S +P1S
     &     **2 - P2S*P4S + P2S*P2P3S + P4S*P1P2S - P1P2S*P2P3S )
      D0wdd(4) = D0wdd(4) + C0w(1,P1P2S,P3S,P4S,M1S,M3S,M4S)*IG3 * (
     &     -P1S*P3S + P1S*P4S - P1S*P1P2S + P2S*P3S - P2S*P4S - P2S
     &     *P1P2S- P3S*P1P2S - P4S*P1P2S + 2*P1P2S*P2P3S + P1P2S**2 )
      D0wdd(4) = D0wdd(4) + D0wdd(1)*IG3 * (  - P1S*P2S*P3S - P1S*P2S
     &     *P4S+ 2*P1S*P2S*P1P2S - P1S*P2S*M1S - P1S*P2S*M3S + 2*P1S*P2S
     &     *M4S - P1S*P3S*P1P2S - P1S*P3S*M1S - P1S*P3S*M2S + 2*P1S*P3S
     &     *M3S + P1S*P4S*M2S - P1S*P4S*M3S - P1S*P1P2S*P2P3S - P1S
     &     *P1P2S*M2S - P1S*P1P2S*M3S + 2*P1S*P1P2S*M4S + P1S*P2P3S*M1S
     &     - P1S*P2P3S*M3S + P1S**2*P3S + P1S**2*M3S - P1S**2*M4S - P2S
     &     *P3S*M1S + P2S*P3S*M2S - P2S*P4S*P1P2S + 2*P2S*P4S*M1S - P2S
     &     *P4S*M2S - P2S*P4S*M3S - P2S*P1P2S*P2P3S - P2S*P1P2S*M1S -
     &     P2S*P1P2S*M2S + 2*P2S*P1P2S*M4S - P2S*P2P3S*M1S + P2S*P2P3S
     &     *M3S+ P2S**2*P4S + P2S**2*M1S - P2S**2*M4S + P3S*P1P2S*M1S -
     &     P3S*P1P2S*M2S - P4S*P1P2S*M2S + P4S*P1P2S*M3S - P1P2S*P2P3S
     &     *M1S+ 2*P1P2S*P2P3S*M2S - P1P2S*P2P3S*M3S + P1P2S**2*P2P3S
     &     +P1P2S**2*M2S - P1P2S**2*M4S )
      D0wdd(4) = D0wdd(4)/4
C-----------------------------------------------------------------------

      D0wdd(5) = + C0w(1,P2S,P3S,P2P3S,M2S,M3S,M4S) * ( 2 )
      D0wdd(5) = D0wdd(5) + D0wdd(1) * ( 4*M1S )
      D0wdd(5) = D0wdd(5) + D0wdd(2) * ( 2*P1S + 2*M1S - 2*M2S )
      D0wdd(5) = D0wdd(5) + D0wdd(3) * ( 2*P1P2S + 2*M1S - 2*M3S )
      D0wdd(5) = D0wdd(5) + D0wdd(4) * ( 2*P4S + 2*M1S - 2*M4S )
      D0wdd(5) = D0wdd(5)/4

      D0wdd(6) =
     &     + C0w(1,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (  - 2*P1S*P3S +
     &     P2S*P3S + P2S*P4S - P2S*P1P2S - P3S*P4S - P3S*P1P2S + P3S
     &     *P2P3S- 2*P4S*P1P2S - P4S*P2P3S + P4S**2 + P1P2S*P2P3S +
     &     P1P2S**2)
      D0wdd(6) = D0wdd(6) + C0w(2,P1S,P2S,P1P2S,M1S,M2S,M3S)*IG3 * (
     &     -P1S*P3S + P1S*P4S - P1S*P1P2S + P2S*P3S - P2S*P4S - P2S
     &     *P1P2S- P3S*P1P2S - P4S*P1P2S + 2*P1P2S*P2P3S + P1P2S**2 )
      D0wdd(6) = D0wdd(6) + C0w(2,P1S,P2P3S,P4S,M1S,M2S,M4S)*IG3 * (
     &     -P1S*P3S - P1S*P4S + P1S*P1P2S + 2*P2S*P4S - P3S*P4S + P3S
     &     *P2P3S - P4S*P1P2S - P4S*P2P3S + P4S**2 - P1P2S*P2P3S )
      D0wdd(6) = D0wdd(6) + C0w(2,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (
     &     - 2*P1S*P3S + P2S*P3S + P2S*P4S - P2S*P1P2S + P3S*P4S + P3S
     &     *P1P2S + P3S*P2P3S - P3S**2 - P4S*P2P3S + P1P2S*P2P3S )
      D0wdd(6) = D0wdd(6) + C0w(3,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (
     &     - 2*P1S*P3S + P2S*P3S + P2S*P4S - P2S*P1P2S + P3S*P4S + P3S
     &     *P1P2S + P3S*P2P3S - P3S**2 - P4S*P2P3S + P1P2S*P2P3S )
      D0wdd(6) = D0wdd(6) + D0wdd(1)*IG3 * (  - 4*P3S*P4S*M1S - 4*P3S
     &     *P1P2S*M1S + 2*P3S**2*M1S - 4*P4S*P1P2S*M1S + 2*P4S**2*M1S +
     &     2*P1P2S**2*M1S )
      D0wdd(6) = D0wdd(6) + D0wdd(2)*IG3 * (  - 3*P1S*P3S*P4S - 3*P1S
     &     *P3S*P1P2S + 2*P1S*P3S*M1S - P1S*P3S*M3S - P1S*P3S*M4S + 2
     &     *P1S*P3S**2 - 2*P1S*P4S*P1P2S - P1S*P4S*M3S + P1S*P4S*M4S +
     &     P1S*P4S**2 + P1S*P1P2S*M3S - P1S*P1P2S*M4S + P1S*P1P2S**2 -
     &     P2S*P3S*P4S - P2S*P3S*M1S + P2S*P3S*M4S - P2S*P4S*P1P2S - P2S
     &     *P4S*M1S + 2*P2S*P4S*M3S - P2S*P4S*M4S + P2S*P4S**2 + P2S
     &     *P1P2S*M1S - P2S*P1P2S*M4S + 2*P3S*P4S*P1P2S - 3*P3S*P4S*M1S
     &     + 4*P3S*P4S*M2S - P3S*P4S*M3S - P3S*P1P2S*P2P3S - 3*P3S*P1P2S
     &     *M1S +4*P3S*P1P2S*M2S - P3S*P1P2S*M4S - P3S*P2P3S*M1S + P3S
     &     *P2P3S*M3S + 2*P3S**2*M1S - 2*P3S**2*M2S - P4S*P1P2S*P2P3S -
     &     2*P4S*P1P2S*M1S + 4*P4S*P1P2S*M2S - P4S*P1P2S*M3S - P4S*P1P2S
     &     *M4S+ P4S*P2P3S*M1S - P4S*P2P3S*M3S + P4S**2*M1S - 2*P4S**2
     &     *M2S+ P4S**2*M3S - P1P2S*P2P3S*M1S - P1P2S*P2P3S*M3S + 2
     &     *P1P2S*P2P3S*M4S + P1P2S**2*P2P3S + P1P2S**2*M1S - 2*P1P2S**2
     &     *M2S +P1P2S**2*M4S )
      D0wdd(6) = D0wdd(6) + D0wdd(3)*IG3 * (  - 2*P3S*P4S*P1P2S - 2*P3S
     &     *P4S*M1S + 2*P3S*P4S*M3S - 2*P3S*P1P2S*M1S + 2*P3S*P1P2S*M3S
     &     - 2*P3S*P1P2S**2 + P3S**2*P1P2S + P3S**2*M1S - P3S**2*M3S - 2
     &     *P4S*P1P2S*M1S + 2*P4S*P1P2S*M3S - 2*P4S*P1P2S**2 + P4S**2
     &     *P1P2S+ P4S**2*M1S - P4S**2*M3S + P1P2S**2*M1S - P1P2S**2*M3S
     &     +P1P2S**3 )
      D0wdd(6) = D0wdd(6) + D0wdd(4)*IG3 * (  - 2*P3S*P4S*P1P2S - 2*P3S
     &     *P4S*M1S + 2*P3S*P4S*M4S - 2*P3S*P4S**2 - 2*P3S*P1P2S*M1S + 2
     &     *P3S*P1P2S*M4S + P3S**2*P4S + P3S**2*M1S - P3S**2*M4S - 2*P4S
     &     *P1P2S*M1S + 2*P4S*P1P2S*M4S + P4S*P1P2S**2 - 2*P4S**2*P1P2S+
     &     P4S**2*M1S - P4S**2*M4S + P4S**3 + P1P2S**2*M1S - P1P2S**2
     &     *M4S )
      D0wdd(6) = D0wdd(6)/4      

      D0wdd(7) =
     &     + C0w(1,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * ( P1S*P3S + P1S
     &     *P4S- P1S*P1P2S - 2*P2S*P4S + P3S*P4S - P3S*P2P3S + P4S*P1P2S
     &     +P4S*P2P3S - P4S**2 + P1P2S*P2P3S )
      D0wdd(7) = D0wdd(7) + C0w(2,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * ( 2
     &     *P1S*P3S - P2S*P3S - P2S*P4S + P2S*P1P2S - P3S*P4S - P3S
     &     *P1P2S- P3S*P2P3S + P3S**2 + P4S*P2P3S - P1P2S*P2P3S )
      D0wdd(7) = D0wdd(7) + C0w(2,P1P2S,P3S,P4S,M1S,M3S,M4S)*IG3 * ( 2
     &     *P3S*P4S + 2*P3S*P1P2S - P3S**2 + 2*P4S*P1P2S - P4S**2 -P1P2S
     &     **2 )
      D0wdd(7) = D0wdd(7) + C0w(3,P1S,P2S,P1P2S,M1S,M2S,M3S)*IG3 * (
     &     -P1S*P3S + P1S*P4S - P1S*P1P2S + P2S*P3S - P2S*P4S - P2S
     &     *P1P2S- P3S*P1P2S - P4S*P1P2S + 2*P1P2S*P2P3S + P1P2S**2 )
      D0wdd(7) = D0wdd(7) + D0wdd(1)*IG3 * ( 2*P1S*P3S*M1S + 2*P1S*P4S
     &     *M1S- 2*P1S*P1P2S*M1S - 4*P2S*P4S*M1S + 2*P3S*P4S*M1S - 2*P3S
     &     *P2P3S*M1S + 2*P4S*P1P2S*M1S + 2*P4S*P2P3S*M1S - 2*P4S**2*M1S
     &     + 2*P1P2S*P2P3S*M1S )
      D0wdd(7) = D0wdd(7) + D0wdd(2)*IG3 * (  - 2*P1S*P2S*P4S + P1S*P3S
     &     *P4S- P1S*P3S*P2P3S + P1S*P3S*M1S - P1S*P3S*M2S + P1S*P4S
     &     *P1P2S+ P1S*P4S*P2P3S + P1S*P4S*M1S - P1S*P4S*M2S - P1S*P4S
     &     **2 +P1S*P1P2S*P2P3S - P1S*P1P2S*M1S + P1S*P1P2S*M2S + P1S**2
     &     *P3S+ P1S**2*P4S - P1S**2*P1P2S - 2*P2S*P4S*M1S + 2*P2S*P4S
     &     *M2S+ P3S*P4S*M1S - P3S*P4S*M2S - P3S*P2P3S*M1S + P3S*P2P3S
     &     *M2S+ P4S*P1P2S*M1S - P4S*P1P2S*M2S + P4S*P2P3S*M1S - P4S
     &     *P2P3S*M2S - P4S**2*M1S + P4S**2*M2S + P1P2S*P2P3S*M1S -
     &     P1P2S*P2P3S*M2S )
      D0wdd(7) = D0wdd(7) + D0wdd(3)*IG3 * (  - P1S*P3S*P4S + 3*P1S*P3S
     &     *M1S- 2*P1S*P3S*M3S - P1S*P3S*M4S + P1S*P3S**2 + P1S*P4S
     &     *P1P2S+ P1S*P4S*M1S - 2*P1S*P4S*M3S + P1S*P4S*M4S - P1S*P1P2S
     &     *M1S+ 2*P1S*P1P2S*M3S - P1S*P1P2S*M4S - P1S*P1P2S**2 - P2S
     &     *P3S*P4S - P2S*P3S*M1S + P2S*P3S*M4S - 3*P2S*P4S*P1P2S - 3
     &     *P2S*P4S*M1S + 4*P2S*P4S*M3S - P2S*P4S*M4S + P2S*P4S**2 + P2S
     &     *P1P2S*M1S - P2S*P1P2S*M4S + 3*P3S*P4S*P1P2S + 2*P3S*P4S*M2S
     &     - 2*P3S*P4S*M3S - 2*P3S*P1P2S*P2P3S - P3S*P1P2S*M1S + 2*P3S
     &     *P1P2S*M2S - P3S*P1P2S*M4S - 2*P3S*P2P3S*M1S + 2*P3S*P2P3S
     &     *M3S +P3S**2*M1S - P3S**2*M2S + P4S*P1P2S*M1S + 2*P4S*P1P2S
     &     *M2S - 2*P4S*P1P2S*M3S - P4S*P1P2S*M4S + P4S*P1P2S**2 + 2*P4S
     &     *P2P3S*M1S - 2*P4S*P2P3S*M3S - P4S**2*P1P2S - P4S**2*M1S -
     &     P4S**2*M2S + 2*P4S**2*M3S - 2*P1P2S*P2P3S*M3S + 2*P1P2S*P2P3S
     &     *M4S +2*P1P2S**2*P2P3S - P1P2S**2*M2S + P1P2S**2*M4S )
      D0wdd(7) = D0wdd(7) + D0wdd(4)*IG3 * ( P1S*P3S*P4S + P1S*P3S*M1S -
     &    P1S*P3S*M4S - P1S*P4S*P1P2S + P1S*P4S*M1S - P1S*P4S*M4S + P1S
     &    *P4S**2 - P1S*P1P2S*M1S + P1S*P1P2S*M4S - 2*P2S*P4S*M1S + 2*
     &    P2S*P4S*M4S - 2*P2S*P4S**2 - P3S*P4S*P2P3S + P3S*P4S*M1S -
     &    P3S*P4S*M4S + P3S*P4S**2 - P3S*P2P3S*M1S + P3S*P2P3S*M4S +
     &    P4S*P1P2S*P2P3S + P4S*P1P2S*M1S - P4S*P1P2S*M4S + P4S*P2P3S*
     &    M1S - P4S*P2P3S*M4S + P4S**2*P1P2S + P4S**2*P2P3S - P4S**2*
     &    M1S + P4S**2*M4S - P4S**3 + P1P2S*P2P3S*M1S - P1P2S*P2P3S*M4S
     &     )
      D0wdd(7) = D0wdd(7)/4

      D0wdd(8) =
     &     + C0w(1,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * ( P1S*P3S - P1S
     &     *P4S+ P1S*P1P2S - P2S*P3S + P2S*P4S + P2S*P1P2S + P3S*P1P2S
     &     +P4S*P1P2S - 2*P1P2S*P2P3S - P1P2S**2 )
      D0wdd(8) = D0wdd(8) + C0w(3,P1S,P2P3S,P4S,M1S,M2S,M4S)*IG3 * (
     &     -P1S*P3S - P1S*P4S + P1S*P1P2S + 2*P2S*P4S - P3S*P4S + P3S
     &     *P2P3S - P4S*P1P2S - P4S*P2P3S + P4S**2 - P1P2S*P2P3S )
      D0wdd(8) = D0wdd(8) + C0w(3,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * ( 2
     &     *P1S*P3S - P2S*P3S - P2S*P4S + P2S*P1P2S - P3S*P4S - P3S
     &     *P1P2S- P3S*P2P3S + P3S**2 + P4S*P2P3S - P1P2S*P2P3S )
      D0wdd(8) = D0wdd(8) + C0w(3,P1P2S,P3S,P4S,M1S,M3S,M4S)*IG3 * ( 2
     &     *P3S*P4S + 2*P3S*P1P2S - P3S**2 + 2*P4S*P1P2S - P4S**2 -P1P2S
     &     **2 )
      D0wdd(8) = D0wdd(8) + D0wdd(1)*IG3 * ( 2*P1S*P3S*M1S - 2*P1S*P4S
     &     *M1S+ 2*P1S*P1P2S*M1S - 2*P2S*P3S*M1S + 2*P2S*P4S*M1S + 2*P2S
     &     *P1P2S*M1S + 2*P3S*P1P2S*M1S + 2*P4S*P1P2S*M1S - 4*P1P2S
     &     *P2P3S*M1S - 2*P1P2S**2*M1S )
      D0wdd(8) = D0wdd(8) + D0wdd(2)*IG3 * (  - P1S*P2S*P3S + P1S*P2S
     &     *P4S+ P1S*P2S*P1P2S + P1S*P3S*P1P2S + P1S*P3S*M1S - P1S*P3S
     &     *M2S+ P1S*P4S*P1P2S - P1S*P4S*M1S + P1S*P4S*M2S - 2*P1S*P1P2S
     &     *P2P3S + P1S*P1P2S*M1S - P1S*P1P2S*M2S - P1S*P1P2S**2 + P1S
     &     **2*P3S - P1S**2*P4S + P1S**2*P1P2S - P2S*P3S*M1S + P2S*P3S
     &     *M2S+ P2S*P4S*M1S - P2S*P4S*M2S + P2S*P1P2S*M1S - P2S*P1P2S
     &     *M2S+ P3S*P1P2S*M1S - P3S*P1P2S*M2S + P4S*P1P2S*M1S - P4S
     &     *P1P2S*M2S - 2*P1P2S*P2P3S*M1S + 2*P1P2S*P2P3S*M2S - P1P2S**2
     &     *M1S +P1P2S**2*M2S )
      D0wdd(8) = D0wdd(8) + D0wdd(3)*IG3 * ( P1S*P3S*P1P2S + P1S*P3S*M1S
     &     -P1S*P3S*M3S - P1S*P4S*P1P2S - P1S*P4S*M1S + P1S*P4S*M3S +
     &     P1S*P1P2S*M1S - P1S*P1P2S*M3S + P1S*P1P2S**2 - P2S*P3S*P1P2S
     &     -P2S*P3S*M1S + P2S*P3S*M3S + P2S*P4S*P1P2S + P2S*P4S*M1S -
     &     P2S*P4S*M3S + P2S*P1P2S*M1S - P2S*P1P2S*M3S + P2S*P1P2S**2 +
     &     P3S*P1P2S*M1S - P3S*P1P2S*M3S + P3S*P1P2S**2 + P4S*P1P2S*M1S
     &     -P4S*P1P2S*M3S + P4S*P1P2S**2 - 2*P1P2S*P2P3S*M1S + 2*P1P2S
     &     *P2P3S*M3S - 2*P1P2S**2*P2P3S - P1P2S**2*M1S + P1P2S**2*M3S
     &     -P1P2S**3 )
      D0wdd(8) = D0wdd(8) + D0wdd(4)*IG3 * (  - P1S*P3S*P1P2S + 3*P1S
     &     *P3S*M1S - P1S*P3S*M3S - 2*P1S*P3S*M4S + P1S*P3S**2 + P1S*P4S
     &     *P1P2S - P1S*P4S*M1S - P1S*P4S*M3S + 2*P1S*P4S*M4S - P1S*P4S
     &     **2 + P1S*P1P2S*M1S + P1S*P1P2S*M3S - 2*P1S*P1P2S*M4S - 2*P2S
     &     *P3S*P4S - 2*P2S*P3S*M1S + 2*P2S*P3S*M4S + 2*P2S*P4S*M3S- 2
     &     *P2S*P4S*M4S + 2*P2S*P4S**2 + 2*P2S*P1P2S*M1S - 2*P2S*P1P2S
     &     *M4S + 3*P3S*P4S*P1P2S - P3S*P4S*M1S + 2*P3S*P4S*M2S -P3S*P4S
     &     *M3S - P3S*P1P2S*P2P3S + 2*P3S*P1P2S*M2S - 2*P3S*P1P2S*M4S -
     &     P3S*P2P3S*M1S + P3S*P2P3S*M3S + P3S**2*M1S - P3S**2*M2S - 3
     &     *P4S*P1P2S*P2P3S + P4S*P1P2S*M1S + 2*P4S*P1P2S*M2S -P4S*P1P2S
     &     *M3S - 2*P4S*P1P2S*M4S - P4S*P1P2S**2 + P4S*P2P3S*M1S - P4S
     &     *P2P3S*M3S + P4S**2*P1P2S - P4S**2*M2S + P4S**2*M3S- 3*P1P2S
     &     *P2P3S*M1S - P1P2S*P2P3S*M3S + 4*P1P2S*P2P3S*M4S +P1P2S**2
     &     *P2P3S - P1P2S**2*M1S - P1P2S**2*M2S + 2*P1P2S**2*M4S)
      D0wdd(8) = D0wdd(8)/8

      D0wdd(9) =
     &     + C0w(1,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (  - 2*P1S*P4S - 2
     &     *P1S*P2P3S + P1S**2 - 2*P4S*P2P3S + P4S**2 + P2P3S**2 )
      D0wdd(9) = D0wdd(9) + C0w(2,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (
     &     P1S*P2S - P1S*P3S - P1S*P2P3S - P2S*P4S - P2S*P2P3S + P3S*P4S
     &     -P3S*P2P3S - P4S*P2P3S + 2*P1P2S*P2P3S + P2P3S**2 )
      D0wdd(9) = D0wdd(9) + C0w(2,P1P2S,P3S,P4S,M1S,M3S,M4S)*IG3 * (
     &     -P1S*P3S - P1S*P4S + P1S*P1P2S + 2*P2S*P4S - P3S*P4S + P3S
     &     *P2P3S - P4S*P1P2S - P4S*P2P3S + P4S**2 - P1P2S*P2P3S )
      D0wdd(9) = D0wdd(9) + C0w(3,P1S,P2S,P1P2S,M1S,M2S,M3S)*IG3 * (
     &     -P1S*P2S + 2*P1S*P3S - P1S*P4S - P1S*P1P2S - P1S*P2P3S +P1S
     &     **2 - P2S*P4S + P2S*P2P3S + P4S*P1P2S - P1P2S*P2P3S )
      D0wdd(9) = D0wdd(9) + D0wdd(1)*IG3 * (  - 4*P1S*P4S*M1S - 4*P1S
     &     *P2P3S*M1S + 2*P1S**2*M1S - 4*P4S*P2P3S*M1S + 2*P4S**2*M1S +
     &     2*P2P3S**2*M1S )
      D0wdd(9) = D0wdd(9) + D0wdd(2)*IG3 * (  - 2*P1S*P4S*P2P3S - 2*P1S
     &     *P4S*M1S + 2*P1S*P4S*M2S + P1S*P4S**2 - 2*P1S*P2P3S*M1S + 2
     &     *P1S*P2P3S*M2S + P1S*P2P3S**2 - 2*P1S**2*P4S - 2*P1S**2*P2P3S
     &     +P1S**2*M1S - P1S**2*M2S + P1S**3 - 2*P4S*P2P3S*M1S + 2*P4S
     &     *P2P3S*M2S + P4S**2*M1S - P4S**2*M2S + P2P3S**2*M1S - P2P3S
     &     **2*M2S )
      D0wdd(9) = D0wdd(9) + D0wdd(3)*IG3 * (  - P1S*P2S*P4S + P1S*P2S
     &     *M1S- P1S*P2S*M4S - P1S*P3S*P4S - P1S*P3S*P2P3S - P1S*P3S*M1S
     &     -P1S*P3S*M2S + 2*P1S*P3S*M4S - 2*P1S*P4S*P1P2S + 2*P1S*P4S
     &     *P2P3S - 2*P1S*P4S*M1S - P1S*P4S*M2S + 4*P1S*P4S*M3S - P1S
     &     *P4S*M4S - 3*P1S*P1P2S*P2P3S + P1S*P1P2S*M2S - P1S*P1P2S*M4S
     &     - 3*P1S*P2P3S*M1S + 4*P1S*P2P3S*M3S - P1S*P2P3S*M4S + P1S**2
     &     *P3S+ P1S**2*P1P2S + P1S**2*M1S - 2*P1S**2*M3S + P1S**2*M4S
     &     -P2S*P4S*P2P3S - P2S*P4S*M1S + 2*P2S*P4S*M2S - P2S*P4S*M4S
     &     +P2S*P4S**2 - P2S*P2P3S*M1S + P2S*P2P3S*M4S + P3S*P4S*M1S
     &     -P3S*P4S*M2S - P3S*P2P3S*M1S + P3S*P2P3S*M2S - 3*P4S*P1P2S
     &     *P2P3S - P4S*P1P2S*M2S + P4S*P1P2S*M4S - 3*P4S*P2P3S*M1S -
     &     P4S*P2P3S*M2S + 4*P4S*P2P3S*M3S + P4S**2*P1P2S + P4S**2*M1S
     &     +P4S**2*M2S - 2*P4S**2*M3S + 2*P1P2S*P2P3S*M1S - P1P2S*P2P3S
     &     *M2S - P1P2S*P2P3S*M4S + 2*P1P2S*P2P3S**2 + 2*P2P3S**2*M1S -
     &     2*P2P3S**2*M3S )
      D0wdd(9) = D0wdd(9) + D0wdd(4)*IG3 * (  - 2*P1S*P4S*P2P3S - 2*P1S
     &     *P4S*M1S + 2*P1S*P4S*M4S - 2*P1S*P4S**2 - 2*P1S*P2P3S*M1S + 2
     &     *P1S*P2P3S*M4S + P1S**2*P4S + P1S**2*M1S - P1S**2*M4S - 2*P4S
     &     *P2P3S*M1S + 2*P4S*P2P3S*M4S + P4S*P2P3S**2 - 2*P4S**2*P2P3S+
     &     P4S**2*M1S - P4S**2*M4S + P4S**3 + P2P3S**2*M1S - P2P3S**2
     &     *M4S )
      D0wdd(9) = D0wdd(9)/4

      D0wdd(10) =
     &     + C0w(1,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * ( P1S*P2S - 2*P1S*
     &    P3S + P1S*P4S + P1S*P1P2S + P1S*P2P3S - P1S**2 + P2S*P4S -
     &    P2S*P2P3S - P4S*P1P2S + P1P2S*P2P3S )
      D0wdd(10) = D0wdd(10) + C0w(3,P1S,P2P3S,P4S,M1S,M2S,M4S)*IG3 * (
     &     2*P1S*P4S + 2*P1S*P2P3S - P1S**2 + 2*P4S*P2P3S - P4S**2
     &     -P2P3S**2 )
      D0wdd(10) = D0wdd(10) + C0w(3,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (
     &    P1S*P2S - P1S*P3S - P1S*P2P3S - P2S*P4S - P2S*P2P3S + P3S*P4S
     &     - P3S*P2P3S - P4S*P2P3S + 2*P1P2S*P2P3S + P2P3S**2 )
      D0wdd(10) = D0wdd(10) + C0w(3,P1P2S,P3S,P4S,M1S,M3S,M4S)*IG3 * (
     &     - P1S*P3S - P1S*P4S + P1S*P1P2S + 2*P2S*P4S - P3S*P4S + P3S*
     &    P2P3S - P4S*P1P2S - P4S*P2P3S + P4S**2 - P1P2S*P2P3S )
      D0wdd(10) = D0wdd(10) + D0wdd(1)*IG3 * ( 2*P1S*P2S*M1S - 4*P1S*P3S
     &     *M1S + 2*P1S*P4S*M1S + 2*P1S*P1P2S*M1S + 2*P1S*P2P3S*M1S - 2
     &     *P1S**2*M1S + 2*P2S*P4S*M1S - 2*P2S*P2P3S*M1S - 2*P4S*P1P2S
     &     *M1S + 2*P1P2S*P2P3S*M1S )
      D0wdd(10) = D0wdd(10) + D0wdd(2)*IG3 * ( P1S*P2S*P4S - P1S*P2S
     &     *P2P3S+ P1S*P2S*M1S - P1S*P2S*M2S - 2*P1S*P3S*M1S + 2*P1S*P3S
     &     *M2S- P1S*P4S*P1P2S + P1S*P4S*M1S - P1S*P4S*M2S + P1S*P1P2S
     &     *P2P3S + P1S*P1P2S*M1S - P1S*P1P2S*M2S + P1S*P2P3S*M1S - P1S
     &     *P2P3S*M2S + P1S**2*P2S - 2*P1S**2*P3S + P1S**2*P4S + P1S**2
     &     *P1P2S + P1S**2*P2P3S - P1S**2*M1S + P1S**2*M2S - P1S**3 +
     &     P2S*P4S*M1S - P2S*P4S*M2S - P2S*P2P3S*M1S + P2S*P2P3S*M2S -
     &     P4S*P1P2S*M1S + P4S*P1P2S*M2S + P1P2S*P2P3S*M1S - P1P2S*P2P3S
     &     *M2S)
      D0wdd(10) = D0wdd(10) + D0wdd(3)*IG3 * ( P1S*P2S*P1P2S + P1S*P2S
     &     *M1S- P1S*P2S*M3S - 2*P1S*P3S*P1P2S - 2*P1S*P3S*M1S + 2*P1S
     &     *P3S*M3S + P1S*P4S*P1P2S + P1S*P4S*M1S - P1S*P4S*M3S + P1S
     &     *P1P2S*P2P3S + P1S*P1P2S*M1S - P1S*P1P2S*M3S + P1S*P1P2S**2 +
     &     P1S*P2P3S*M1S - P1S*P2P3S*M3S - P1S**2*P1P2S - P1S**2*M1S
     &     +P1S**2*M3S + P2S*P4S*P1P2S + P2S*P4S*M1S - P2S*P4S*M3S - P2S
     &     *P1P2S*P2P3S - P2S*P2P3S*M1S + P2S*P2P3S*M3S - P4S*P1P2S*M1S+
     &     P4S*P1P2S*M3S - P4S*P1P2S**2 + P1P2S*P2P3S*M1S - P1P2S*P2P3S
     &     *M3S + P1P2S**2*P2P3S )
      D0wdd(10) = D0wdd(10) + D0wdd(4)*IG3 * ( 2*P1S*P2S*M1S - 2*P1S*P2S
     &     *M4S - 3*P1S*P3S*P4S - P1S*P3S*P2P3S - 3*P1S*P3S*M1S - P1S
     &     *P3S*M2S + 4*P1S*P3S*M4S + P1S*P4S*P1P2S + 3*P1S*P4S*P2P3S +
     &     P1S*P4S*M1S - P1S*P4S*M2S + 2*P1S*P4S*M3S - 2*P1S*P4S*M4S +
     &     P1S*P4S**2 - P1S*P1P2S*P2P3S + P1S*P1P2S*M1S + P1S*P1P2S*M2S
     &     - 2*P1S*P1P2S*M4S + 2*P1S*P2P3S*M3S - 2*P1S*P2P3S*M4S + P1S
     &     **2*P3S - P1S**2*P4S - P1S**2*M1S - P1S**2*M3S + 2*P1S**2*M4S
     &     - 2*P2S*P4S*P2P3S + 2*P2S*P4S*M2S - 2*P2S*P4S*M4S + 2*P2S*P4S
     &     **2- 2*P2S*P2P3S*M1S + 2*P2S*P2P3S*M4S + P3S*P4S*M1S - P3S
     &     *P4S*M2S - P3S*P2P3S*M1S + P3S*P2P3S*M2S - P4S*P1P2S*M1S -
     &     P4S*P1P2S*M2S + 2*P4S*P1P2S*M4S - P4S*P2P3S*M1S - P4S*P2P3S
     &     *M2S+ 2*P4S*P2P3S*M3S - P4S**2*P1P2S + P4S**2*M2S - P4S**2
     &     *M3S+ 3*P1P2S*P2P3S*M1S - P1P2S*P2P3S*M2S - 2*P1P2S*P2P3S*M4S
     &     +P1P2S*P2P3S**2 + P2P3S**2*M1S - P2P3S**2*M3S )
      D0wdd(10) = D0wdd(10)/4

      D0wdd(11) =
     &     + C0w(1,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (  - 2*P1S*P2S - 2
     &     *P1S*P1P2S + P1S**2 - 2*P2S*P1P2S + P2S**2 + P1P2S**2 )
      D0wdd(11) = D0wdd(11) + C0w(3,P1S,P2P3S,P4S,M1S,M2S,M4S)*IG3 * (
     &     - P1S*P2S + 2*P1S*P3S - P1S*P4S - P1S*P1P2S - P1S*P2P3S +
     &     P1S**2 - P2S*P4S + P2S*P2P3S + P4S*P1P2S - P1P2S*P2P3S )
      D0wdd(11) = D0wdd(11) + C0w(3,P2S,P3S,P2P3S,M2S,M3S,M4S)*IG3 * (
     &     - P1S*P2S - P1S*P3S + P1S*P2P3S - P2S*P3S + 2*P2S*P4S - P2S*
     &     P1P2S - P2S*P2P3S + P2S**2 + P3S*P1P2S - P1P2S*P2P3S )
      D0wdd(11) = D0wdd(11) + C0w(3,P1P2S,P3S,P4S,M1S,M3S,M4S)*IG3 * (
     &     - P1S*P3S + P1S*P4S - P1S*P1P2S + P2S*P3S - P2S*P4S - P2S*
     &     P1P2S - P3S*P1P2S - P4S*P1P2S + 2*P1P2S*P2P3S + P1P2S**2 )
      D0wdd(11) = D0wdd(11) + D0wdd(1)*IG3 * (  - 4*P1S*P2S*M1S - 4*P1S*
     &     P1P2S*M1S + 2*P1S**2*M1S - 4*P2S*P1P2S*M1S + 2*P2S**2*M1S + 2
     &     *P1P2S**2*M1S )
      D0wdd(11) = D0wdd(11) + D0wdd(2)*IG3 * (  - 2*P1S*P2S*P1P2S - 2
     &     *P1S*P2S*M1S + 2*P1S*P2S*M2S + P1S*P2S**2 - 2*P1S*P1P2S*M1S +
     &     2*P1S*P1P2S*M2S + P1S*P1P2S**2 - 2*P1S**2*P2S - 2*P1S**2
     &     *P1P2S+ P1S**2*M1S - P1S**2*M2S + P1S**3 - 2*P2S*P1P2S*M1S +
     &     2*P2S*P1P2S*M2S + P2S**2*M1S - P2S**2*M2S + P1P2S**2*M1S
     &     -P1P2S**2*M2S )
      D0wdd(11) = D0wdd(11) + D0wdd(3)*IG3 * (  - 2*P1S*P2S*P1P2S - 2
     &     *P1S*P2S*M1S + 2*P1S*P2S*M3S - 2*P1S*P1P2S*M1S + 2*P1S*P1P2S
     &     *M3S- 2*P1S*P1P2S**2 + P1S**2*P1P2S + P1S**2*M1S - P1S**2*M3S
     &     -2*P2S*P1P2S*M1S + 2*P2S*P1P2S*M3S - 2*P2S*P1P2S**2 + P2S**2
     &     *P1P2S + P2S**2*M1S - P2S**2*M3S + P1P2S**2*M1S - P1P2S**2
     &     *M3S+ P1P2S**3 )
      D0wdd(11) = D0wdd(11) + D0wdd(4)*IG3 * (  - P1S*P2S*P3S - 3*P1S
     &     *P2S*P4S + 2*P1S*P2S*P1P2S - 3*P1S*P2S*M1S - P1S*P2S*M3S + 4
     &     *P1S*P2S*M4S - P1S*P3S*P1P2S - P1S*P3S*M1S - P1S*P3S*M2S + 2
     &     *P1S*P3S*M3S - 2*P1S*P4S*P1P2S + P1S*P4S*M2S - P1S*P4S*M3S -
     &     P1S*P1P2S*P2P3S - 2*P1S*P1P2S*M1S - P1S*P1P2S*M2S - P1S*P1P2S
     &     *M3S+ 4*P1S*P1P2S*M4S + P1S*P2P3S*M1S - P1S*P2P3S*M3S + P1S
     &     **2*P3S + P1S**2*P4S + P1S**2*M1S + P1S**2*M3S - 2*P1S**2*M4S
     &     -P2S*P3S*M1S + P2S*P3S*M2S - 3*P2S*P4S*P1P2S + 2*P2S*P4S*M1S-
     &     P2S*P4S*M2S - P2S*P4S*M3S - P2S*P1P2S*P2P3S - 3*P2S*P1P2S*M1S
     &     - P2S*P1P2S*M2S + 4*P2S*P1P2S*M4S - P2S*P2P3S*M1S + P2S*P2P3S
     &     *M3S + 2*P2S**2*P4S + 2*P2S**2*M1S - 2*P2S**2*M4S + P3S*P1P2S
     &     *M1S - P3S*P1P2S*M2S - P4S*P1P2S*M2S + P4S*P1P2S*M3S +P4S
     &     *P1P2S**2 - P1P2S*P2P3S*M1S + 2*P1P2S*P2P3S*M2S - P1P2S*P2P3S
     &     *M3S + P1P2S**2*P2P3S + P1P2S**2*M1S + P1P2S**2*M2S - 2*P1P2S
     &     **2*M4S )
      D0wdd(11) = D0wdd(11)/4      
C-----------------------------------------------------------------------
      do i=1,11
        if (index.EQ.i) D0w=D0wdd(i)
*        print *,'D(',i,')=',D0wdd(i)
      enddo
C-----------------------------------------------------------------------
      return
      end


CC $Id: d0w.F,v 1.9 2004/10/14 11:27:27 alorca Exp $
